// Physics Constrain Editor, based on the "Visual Level Editor". Credits to Shadow696
///////////////////////////////
#include <acknex.h>
#include <default.c>
///////////////////////////////

#define id skill60
#define ph skill59

#define MAP_OBJ 0
#define GAME_CONTROL 1
#define PH_MAKE_CONST 2
#define BOX 3
#define SPHERE 4
#define CYLINDER 5
#define POLY 6

#define PRAGMA_PATH "./bmaps_dir";

var ph_prev_mode=0;

var obj_num=0;
var id_copy;

var enter_mode=0;
VECTOR ent_scale;
VECTOR cam_pos; //use for preview mode
VECTOR cam_ang;//use for preview mode
VECTOR world_g; //world gravity
var move_group=0;
var scale_group=0;
var rot_group=0;
var bone_size = 1;
var cam_moving_speed=20;

var caxis_by_radius=1;
var a_translucent=1; //auto 
var a_fix=1;  //auto fix error
var a_unt_set=1;  //auto set UTOCHABLE
var a_first_fun=1; //
var a_draw_anchor=1;
var a_draw_wireframe=1;
var a_scale_entbone=1;
var a_kick_power=1000;
var draw_s_axis=0; //draw xyz axis
var a_set_sky=1;
var a_box_sphere=1;

var loading_level=0; // set to 1 then loading new level
var draw_anchor=0;


///SKY
#define ENV_NULL 0
#define ENV_DOME 1
#define ENV_CUBE 2
#define ENV_CYLINDER 3
#define ENV_SCENE 4
STRING* sky_name = "None";
ENTITY* last_sky = NULL;
ENTITY* now_sky = NULL;
var env_flag2 = ENV_CUBE;
var env_flag_sky=1;
var env_layer=0;
VECTOR env_sun;
VECTOR env_sky_col;
VECTOR env_fog_color;
VECTOR env_fog_draw; // x-fog_start y-fog_end z-draw_for (1|0)
VECTOR env_shadow; // x-mat_shadow.alpha // y- mat_shadow.mode z - 0
function load_layer_ent ()
{
	if (str_cmpi(sky_name,"None")||str_cmpi(sky_name,"")) return;
	var entflag=0;
	if (env_flag_sky)  entflag |= SKY;
	if (env_flag2==ENV_DOME)  entflag |= DOME;
	if (env_flag2==ENV_CUBE)  entflag |= CUBE;
	if (env_flag2==ENV_CYLINDER)  entflag |= CYLINDER;
	if (env_flag2==ENV_SCENE)  entflag |= SCENE;
	if (now_sky==NULL) 
	{
		now_sky = ent_createlayer(sky_name,entflag,env_layer);
		str_for_entfile(sky_name,now_sky);
		if (str_cmpi(sky_name,"")) str_cpy(sky_name,"None");
		now_sky.parent = NULL;
	}
		else 
	{
		last_sky = now_sky;
		now_sky = ent_createlayer(sky_name,entflag,env_layer);
		now_sky.parent = last_sky;
	} 
	
}
///////////////////////SKY 

var prev_constrain=0;
var anim_prec;
STRING* fileopen="";
STRING* obj_dir = "save_dir\\"; // dir to save *.ent file, and load help *.txt
STRING* nulltxtfile = "null.txt";
STRING* actionfile = "action.txt";
STRING* materialfile = "material.txt";
STRING* empy_string = "           ";
STRING* cfg_dir = "cfg\\";
STRING* entity_dir_cfg = "entity_dir.cfg";
STRING* save_dir_cfg = "save_dir.cfg";

var del;

ENTITY* select = NULL;
ENTITY* select_sec = NULL;

ENTITY* w_select=NULL;
ENTITY* w_select_sec=NULL;
ENTITY* anchor=NULL;
ENTITY* ent_const=NULL;
ENTITY* ent_attach=NULL; 
ENTITY* ent_prof=NULL;


BMAP* sl_1 = "slider_back.png";
BMAP* sl_2 = "slider.png";
BMAP* sl_3 = "slider_small.png";
BMAP* vec_panel = "vector.png";
BMAP* var_bmap = "var.png";
BMAP* small_b = "small.png";
BMAP* small_b2 = "small2.png";
BMAP* radio_bon = "b_toggle_on.png";
BMAP* radio_bover = "b_toggle_over.png";
BMAP* radio_boff = "b_toggle_off.png";
BMAP* background1 = "background1.png";
BMAP* background2 = "background2.png";
BMAP* background3 = "background3.png";
BMAP* background4 = "background4.png";
BMAP* background5 = "background5.png";
BMAP* background6 = "background6.png";
BMAP* background7 = "background7.png";
BMAP* background8 = "background8.png";
BMAP* prev_mode_bmap = "prev_mode.png";
BMAP* button_green = "button_green.png";
BMAP* bmap_intro = "intro.jpg";
BMAP* bmap_ok = "ok.png";
BMAP* bmap_ok_r = "ok_r.png";
//BMAP* bmap_cancel = "cancel.png";
//BMAP* bmap_cancel_r = "cancel_r.png";
BMAP* mouse_p = "mouse.bmp";
FONT* arial_font = "Arial#15b";
FONT* file_font = "Arial#20b";
FONT* arial_big = "Arial#30b";
TEXT* f1helptext = {pos_x=10;strings=300;font=arial_font;layer=20;}// load text from editor_help.txt (hotKeys)


typedef struct 
{ 
	var obj_type;
	var const_type;
	char* file;
	char* name;
	char* constrain; //name of entity
	char* add_ent; //name of entity that attach bone
	char* bone1; // name of entString1 or bone name(for ph obj)
	char* bone2; // name of entString2
	char* _action;
	char* _material;
	
	VECTOR pos; //temporary param
	VECTOR scale;//temporary param
	VECTOR angle;//temporary param
	VECTOR egroup;//temporary param
	
	VECTOR ph_maxs; //xy-maxspeed (0,0) unlim speed  z - bone parent index (set by editor)
	VECTOR ph_mass; // x -mass yz - damping 
	VECTOR ph_elast; //xy-elasticity  z-friction
	
	VECTOR phcon_p1; //Anchor point if xyz==0 -> use automatic
	VECTOR phcon_p2;
	VECTOR phcon_p3;
	VECTOR phcon_p4;
	VECTOR phcon_p5;
	VECTOR phcon_p6;
	VECTOR phcon_mot1; // set motor
	VECTOR phcon_mot2;
	
	VECTOR s_param;  // x- set INVISIBLE in Game (dont hide in EDITOR); y - constarain invert; z - ent group
	
} PH_ENT ;

PH_ENT ph_obj[1000];

///////////////////////
#include "draw.c"
#include "select.c"
#include "opensave.c"
#include "panels.c"
#include "ph_prev_mode.c"
///////////////

TEXT* pDrawX = {font = arial_font;string = "#30";layer=20;}
TEXT* pDrawY = {font = arial_font;string = "#30";layer=20;}
TEXT* pDrawZ = {font = arial_font;string = "#30";layer=20;}
var vec_in_num=0;
STRING* p_info = "#20";
function vecenter (var num,PANEL* panel)
{
	if (proc_status(vecenter)>1) return;
	//if (inkey_active) return; //inkey_active = OFF;
	if (inkey_active) inkey_active = OFF;wait(1);
	vec_in_num=num;
	if (num==1) 
	{
	str_cat((pDrawX.pstring)[0],empy_string);
	result=inkey((pDrawX.pstring)[0]);
	str_for_num((pDrawX.pstring)[0],str_to_num((pDrawX.pstring)[0]));
	beep();if (result==9) vecenter(2,NULL);
	}
	if (num==2) 
	{
	str_cat((pDrawY.pstring)[0],empy_string);
	result=inkey((pDrawY.pstring)[0]);
	str_for_num((pDrawY.pstring)[0],str_to_num((pDrawY.pstring)[0]));
	beep();if (result==9) vecenter(3,NULL);
	}
	if (num==3) 
	{
	str_cat((pDrawZ.pstring)[0],empy_string);
	result=inkey((pDrawZ.pstring)[0]);
	str_for_num((pDrawZ.pstring)[0],str_to_num((pDrawZ.pstring)[0]));
	beep();if (result==9) vecenter(1,NULL);
	}
	
	if (!inkey_active) vec_in_num=0;
}
PANEL* vec_in = 
{
	pos_x = 144; pos_y = 250;
	bmap = vec_panel;
	on_click = paneldrag;
	button (100,64,var_bmap,var_bmap,var_bmap,vecenter,NULL,NULL);
	button (200,64,var_bmap,var_bmap,var_bmap,vecenter,NULL,NULL);
	button (300,64,var_bmap,var_bmap,var_bmap,vecenter,NULL,NULL);
	digits (110,65,"x= ",arial_font,1,0);
	digits (210,65,"y= ",arial_font,1,0);
	digits (310,65,"z= ",arial_font,1,0);
	//digits (0,0,"%s",arial_font,1,vPanCursor);
	digits (100,0,"%s",arial_font,1,p_info);
	layer = 19;
}
function vec_enter(VECTOR* vec,STRING* info) 
{
	if (is(vec_in,VISIBLE)||enter_mode) return;
	enter_mode = 1;
	var counts;
	VECTOR old;
	VECTOR cur_pos;
	vec_set(old,vec);
	str_cpy(p_info,info); 
	str_for_num((pDrawX.pstring)[0],vec.x);
	str_for_num((pDrawY.pstring)[0],vec.y);
	str_for_num((pDrawZ.pstring)[0],vec.z);
	set(vec_in,VISIBLE);
	set(pDrawX,VISIBLE);set(pDrawY,VISIBLE);set(pDrawZ,VISIBLE);
	while(!key_esc)
	{
		pDrawX.pos_x=130+vec_in.pos_x;pDrawX.pos_y=66+vec_in.pos_y;
		pDrawY.pos_x=230+vec_in.pos_x;pDrawY.pos_y=66+vec_in.pos_y;
		pDrawZ.pos_x=330+vec_in.pos_x;pDrawZ.pos_y=66+vec_in.pos_y;
		vec.x = str_to_num((pDrawX.pstring)[0]);
		vec.y = str_to_num((pDrawY.pstring)[0]);
		vec.z = str_to_num((pDrawZ.pstring)[0]);
		if (key_enter&&!inkey_active) {
			reset(vec_in,VISIBLE);reset(pDrawX,VISIBLE);reset(pDrawY,VISIBLE);reset(pDrawZ,VISIBLE);
			enter_mode=0;return;
			}
		wait(1);
	}
	reset(pDrawX,VISIBLE);reset(pDrawY,VISIBLE);reset(pDrawZ,VISIBLE);
	vec_set(vec,old);inkey_active = OFF;reset(vec_in,VISIBLE);enter_mode=0;
	while (proc_status(vecenter)) beep(); ///del thiss
}
PANEL* st_in = 
{
	pos_x = 144; pos_y = 250;
	bmap = vec_panel;
	on_click = paneldrag;
	button (200,64,var_bmap,var_bmap,var_bmap,NULL,NULL,NULL);
	digits (100,0,"%s",arial_font,1,p_info);
	layer = 19;
}

function set_text_dialog ()
{
	while (enter_mode) {pDrawX.pos_x=205+st_in.pos_x;pDrawX.pos_y=66+st_in.pos_y;wait(1);}
}

function string_in (STRING* st,STRING* info)
{
	if (is(st_in,VISIBLE)||enter_mode||m_mode||scale_mode||rot_mode) return; 
	set(st_in,VISIBLE);set(pDrawX,VISIBLE);
	str_cpy((pDrawX.pstring)[0],st);str_cat((pDrawX.pstring)[0],empy_string);
	enter_mode = 1;str_cpy(p_info,info);set_text_dialog();
	result = inkey((pDrawX.pstring)[0]);if (result!=27) str_cpy(st,(pDrawX.pstring)[0]);
	enter_mode = 0;reset(st_in,VISIBLE);reset(pDrawX,VISIBLE);
}

// string dialog box
TEXT* sel_strings  = {strings = 1000;}
var sel_group[1000]; //0-> file nosel 1-> file sel 
TEXT* sel_screen = {strings = 23;font=file_font;layer = 4;}
TEXT* sel_group_screen = {strings = 23;font=file_font;layer = 5;blue=0;green=0;}
TEXT* sel_info_text = {font=arial_font;layer = 5;blue=0;}
BMAP* f_select = "f_select.png";
BMAP* c_select = "choise.png";
STRING* sel_st_info=" ";
var max_st;
var slider_pos;
var select_pos;
var string_click=0;
var select_finish=1; //0->select in process//1->select is finish//2->select was canceled
function choose_click (var num,PANEL* panel) {select_pos=integer(max_st*(slider_pos/1000))+num;string_click=1;}
PANEL* choose_string =
{
	//pos_x = 250;
	bmap = f_select;
	button(30,22,c_select,NULL,c_select,choose_click,NULL,NULL);	
	button(30,42,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,62,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,82,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,102,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,122,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,142,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,162,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,182,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,202,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,222,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,242,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,262,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,282,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,302,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,322,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,342,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,362,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,382,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,402,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,422,c_select,NULL,c_select,choose_click,NULL,NULL);
	button(30,442,c_select,NULL,c_select,choose_click,NULL,NULL);
	vslider (280,10,460,sl_2,0,1000,slider_pos);
	digits = 0,15,"%.0f",*,1,max_st;
	digits = 0,0,"%s",arial_font,1,sel_st_info;
	layer = 3;
}
function strings_sel (var group_mode,STRING* info) //0 -> one string //1- group
{
	if (rot_mode||m_mode||scale_mode||enter_mode||is(choose_string,VISIBLE)||select_finish==0) {return;}
	var count;
	var vtmp;
	str_cpy((sel_info_text.pstring)[0],info);	//str_cpy(sel_st_info,info);
	set(choose_string,VISIBLE);enter_mode=1;select_finish=0;
	set(sel_screen,VISIBLE);set(sel_group_screen,VISIBLE);set(sel_info_text,VISIBLE);
	sel_info_text.pos_x=choose_string.pos_x;sel_info_text.pos_y=choose_string.pos_y;
	sel_screen.pos_x=choose_string.pos_x+33;sel_screen.pos_y=choose_string.pos_y+20;
	sel_group_screen.pos_x=sel_screen.pos_x;sel_group_screen.pos_y=sel_screen.pos_y;
	for(count=0;count<1000;count++)  sel_group[count]=0;
	while(1)
	{
		for(count=0;count<=21;count++) {
			vtmp=integer(max_st*(slider_pos/1000))+count;
			if (vtmp>max_st-1) str_cpy((sel_screen.pstring)[count],""); else
			str_cpy((sel_screen.pstring)[count],(sel_strings.pstring)[vtmp]);
			
			if (vtmp>max_st-1||!sel_group[vtmp]) 
			str_cpy((sel_group_screen.pstring)[count],""); else
			str_cpy((sel_group_screen.pstring)[count],(sel_strings.pstring)[vtmp]);
		}
		if (string_click&&key_shift&&group_mode&&select_pos<=max_st) 
		if (sel_group[select_pos-1]) sel_group[select_pos-1]=0; else sel_group[select_pos-1]=1; 
		
		slider_pos = maxv(0,minv(1000,slider_pos-mickey.z));
	if (group_mode) {if (key_enter) {select_finish=1;break;}} else 
		if (select_pos<=max_st&&string_click) 
		{select_finish=1;sel_group[select_pos-1]=1;break;}//str_cpy(send,(sel_strings.pstring)[select_pos-1]);

		if (key_esc) {select_finish=2;break;}
		string_click=0;select_finish=0;enter_mode=1;wait(1);
	}
	string_click=0;enter_mode=0;reset(choose_string,VISIBLE);reset(sel_screen,VISIBLE);
	reset(sel_group_screen,VISIBLE);reset(sel_info_text,VISIBLE);enter_mode=0;
}
function add_files_to_strings (STRING* in)
{
	TEXT* sor = {strings=300;}
	var num;
	var count=0;
	num = txt_for_dir(sor,in);
	if (max_st+num>1000) return (0);
	while (count<num) {str_cpy((sel_strings.pstring)[count+max_st],(sor.pstring)[count]);count++;}
	max_st+=num;
	return (num);
}

TEXT* work_dirs = {strings=30;}
var max_dirs=0;
function get_dir_files (var mode) //1 - only models 
{
	var all=0;max_st = 0;
	var count=0;
	STRING* dir = "#30";
	while (count<max_dirs)
	{
	
	str_cpy(dir,(work_dirs.pstring)[count]);str_cat(dir,"*.mdl");all+=add_files_to_strings (dir);
	if (!mode)
	{
		str_cpy(dir,(work_dirs.pstring)[count]);str_cat(dir,"*.hmp");all+=add_files_to_strings (dir);
		str_cpy(dir,(work_dirs.pstring)[count]);str_cat(dir,"*.png");all+=add_files_to_strings (dir);
		str_cpy(dir,(work_dirs.pstring)[count]);str_cat(dir,"*.tga");all+=add_files_to_strings (dir);
		str_cpy(dir,(work_dirs.pstring)[count]);str_cat(dir,"*.jpg");all+=add_files_to_strings (dir);
	}
	count++;
	}
	str_cpy(save_dir,work_dir);
	if (!all) 
	{
		str_cpy(dir,"*.mdl");all+=add_files_to_strings (dir);
	}
}

function get_create_pos(VECTOR* pos)
{
	VECTOR temp;vec_set(temp,vector(100,0,0));
	if (select!=NULL) {vec_set(pos,select.x);return;}
	vec_rotate(temp,camera.pan);
	vec_set(pos,camera.x);vec_add(pos,temp);
}


function var_enter (var* myvar, STRING* info)
{
	if (enter_mode) return;
	STRING* st = "#20";
	str_for_num(st,*myvar);
	string_in(st,info);
	if (!is(st_in,VISIBLE)) return;
	while (is(st_in,VISIBLE)) {wait(1);*myvar=str_to_num(st);}
	*myvar=str_to_num(st);return;
}

function scale_enter (ENTITY* this)
{
	ent_scale.x=this.scale_x;ent_scale.y=this.scale_y;ent_scale.z=this.scale_z;
	if (enter_mode) return;
	vec_enter(ent_scale,"Enter Scale");
	if (!is(vec_in,VISIBLE)) return;
	while (is(vec_in,VISIBLE)) {this.scale_x=ent_scale.x;this.scale_y=ent_scale.y;this.scale_z=ent_scale.z;wait(1);}
}

function get_unique_name (STRING* st)
{
	var count=1;
	ENTITY* ent = ent_next(NULL);
	STRING* dig = "digit";
	str_cpy(st,"name_0");
	while (ent!=NULL) 
	{
		if (ent.ph==1)
		{
			str_cpy(dig,ph_obj[ent.id].name);str_clip(dig,5);
			if (str_to_num(dig)>=count) count=str_to_num(dig)+1;
			str_cpy(dig,ph_obj[ent.id].constrain);str_clip(dig,5);
			if (str_to_num(dig)>=count) count=str_to_num(dig)+1;
			str_cpy(dig,ph_obj[ent.id].add_ent);str_clip(dig,5);
			if (str_to_num(dig)>=count) count=str_to_num(dig)+1;
		}
		ent = ent_next(ent);
	}
	str_cpy(st,"name_");str_for_num(dig,count);str_cat(st,dig);
}

function setdef_param (PH_ENT* set_p)
{
	set_p.name = str_create("#25");
	set_p.constrain = str_create("#25");
	set_p.add_ent = str_create("#25");
	set_p.bone1 = str_create("#25");
	set_p.bone2 = str_create("#25");
	set_p._action = str_create("#25");
	set_p._material = str_create("#25");
	
	str_cpy(set_p.constrain,"cons_unused");
	str_cpy(set_p.add_ent,"bonesent_unused");
	str_cpy(set_p.bone1,"string1");
	str_cpy(set_p.bone2,"string2");
	str_cpy(set_p._action,"noaction");
	str_cpy(set_p._material,"nomaterial");
	
	vec_set(set_p.pos,nullvector);vec_zero(set_p.scale);vec_set(set_p.angle,nullvector);
	vec_set(set_p.ph_maxs,nullvector);vec_set(set_p.ph_mass,nullvector);
	vec_set(set_p.ph_elast,nullvector);vec_set(set_p.s_param,nullvector);
	vec_set(set_p.phcon_p1,nullvector);vec_set(set_p.phcon_p2,nullvector);vec_set(set_p.phcon_p3,nullvector);
	vec_set(set_p.phcon_p4,nullvector);vec_set(set_p.phcon_p5,nullvector);vec_set(set_p.phcon_p6,nullvector);
	vec_set(set_p.phcon_mot1,nullvector);vec_set(set_p.phcon_mot2,nullvector);
	vec_set(set_p.egroup,nullvector);

	vec_set(set_p.ph_mass,vector(100,40,40));
	vec_set(set_p.ph_elast,vector(50,20,200));
	set_p.const_type = 0;
}

function _obj_copy_param (PH_ENT* dest,PH_ENT* sor,var copy_mode) //
{	
	//strings
	if (copy_mode==0)
	{
		dest.file = sor.file;
		dest.name=sor.name;
		dest.constrain = sor.constrain;
		dest.add_ent=sor.add_ent;
		dest.bone1=sor.bone1;
		dest.bone2=sor.bone2;
		dest._action=sor._action;
		dest._material=sor._material;} 
	else
	{
		str_cpy(dest.name,sor.name);
		str_cpy(dest.constrain,sor.constrain);
		str_cpy(dest.add_ent,sor.add_ent);
		str_cpy(dest.bone1,sor.bone1);
		str_cpy(dest.bone2,sor.bone2);
		str_cpy(dest._action,sor._action);
		str_cpy(dest._material,sor._material);
	}
	///vars
	dest.obj_type=sor.obj_type;	
	dest.const_type = sor.const_type;
	vec_set(dest.ph_maxs,sor.ph_maxs);
	vec_set(dest.ph_mass,sor.ph_mass);
	vec_set(dest.ph_elast,sor.ph_elast);
	vec_set(dest.s_param,sor.s_param);
	vec_set(dest.phcon_p1,sor.phcon_p1);
	vec_set(dest.phcon_p2,sor.phcon_p2);
	vec_set(dest.phcon_p3,sor.phcon_p3);
	vec_set(dest.phcon_p4,sor.phcon_p4);
	vec_set(dest.phcon_p5,sor.phcon_p5);
	vec_set(dest.phcon_p6,sor.phcon_p6);
	vec_set(dest.phcon_mot1,sor.phcon_mot1);
	vec_set(dest.phcon_mot2,sor.phcon_mot2);

}
function change_model (ENTITY* ent) 
{
	if (enter_mode||rot_mode||scale_mode||m_mode) return;
	if (ph_obj[ent.id].obj_type<=2) get_dir_files (0); else get_dir_files (1);
	strings_sel(0,"Change model");
	if (!is(choose_string,VISIBLE)) return;
	while(!select_finish) wait(1);
	if (select_finish==2) return;
	str_cpy(ph_obj[ent.id].file,(sel_strings.pstring)[select_pos-1]);
	ent_morph(ent,ph_obj[ent.id].file);str_for_entfile(ph_obj[ent.id].file,ent);
}
ENTITY* reg_obj(STRING* model,VECTOR* pos,var obj_type)
{	
	STRING* filename = str_create("#30");
	ENTITY* ent=NULL;
	ent=ent_create(model,pos,NULL);
	str_for_entfile(filename,ent);
	if (str_cmpi(filename,"")) {ent=ent_create("entity_err.mdl",pos,NULL);}
	str_for_entfile(filename,ent);
	if (str_cmpi(filename,"")) return NULL; //no reg -> modelError
	
	ent.id=obj_num;ent.ph=1;
	ph_obj[ent.id].file = filename;
	setdef_param(ph_obj[ent.id]);
	if (obj_type>=0) get_unique_name(ph_obj[ent.id].name);
	ph_obj[ent.id].obj_type = obj_type;
	obj_num++;
	c_setminmax(ent);
	return ent;
}

ENTITY* reg_copy(var num,VECTOR* pos)
{	
	STRING* filename = str_create("#30");
	ENTITY* ent=NULL;
	ent=ent_create(ph_obj[num].file,pos,NULL);
	str_for_entfile(filename, ent);
	if (str_cmpi(filename, "")) {beep();beep();}
	if (str_cmpi(filename, "")) return NULL; //no reg -> modelError
	
	ent.id=obj_num;ent.ph=1;
	ph_obj[ent.id].file = filename;
	setdef_param(ph_obj[ent.id]);
	_obj_copy_param(ph_obj[ent.id],ph_obj[num],1);
	get_unique_name(ph_obj[ent.id].name);
	obj_num++;
	return ent;
}

ENTITY* find_ent_id (var ent_id)
{
	ENTITY* ent;
	ent = ent_next(NULL);
	while(ent!=NULL)
	{
		if (ent.id==ent_id&&ent.ph==1) return (ent);
		ent = ent_next(ent);
	}
	return (NULL);
}

function del_obj(ENTITY* ent)
{
	if (ent==NULL) return;
	ENTITY* this;
	var count=ent.id;
	this=ent_next(NULL);
	while (count<obj_num) 
	{
		this=ent_next(NULL);count++;	
		while (this!=NULL)
		{
			if ((this.ph==1)&&(this.id==count)) 
			{	
				this.id--;
				_obj_copy_param(ph_obj[this.id],ph_obj[this.id+1],0);
			}
			this=ent_next(this);
		}
	}
	obj_num--;
	select_sec=NULL;select = NULL;
	ent_remove(ent); 
}

function select_by_name()
{
	var count;
	if (enter_mode||rot_mode||scale_mode||m_mode||obj_num==0) return;
	max_st = obj_num;
	for(count=0;count<obj_num;count++) str_cpy((sel_strings.pstring)[count],ph_obj[count].name);
	strings_sel(0,"Select by name");
	if (!is(choose_string,VISIBLE)) return;
	while(!select_finish) wait(1);
	if (select_finish==2) return;
	select=find_by_name((sel_strings.pstring)[select_pos-1]);
}

function add_models()
{
	var count;VECTOR tmp;
	if (enter_mode||rot_mode||scale_mode||m_mode) return;
	get_dir_files (1);
	strings_sel(1,"Add models(hold shift,select group,then enter)");
	if (!is(choose_string,VISIBLE)) return;
	while(!select_finish) wait(1);
	if (select_finish==2) return;
	get_create_pos(tmp);
	for (count=0;count<500;count++)
	if (sel_group[count]) 
	{
		you=reg_obj((sel_strings.pstring)[count],tmp,MAP_OBJ);if (you==NULL) break;
		if (select!=NULL) {copy_ent_prop(you,select,0);ph_obj[you.id].s_param.z=ph_obj[select.id].s_param.z;}
		c_setminmax(you);
	}
}
function set_string_from_txt (STRING* dest,STRING* textfile,STRING* info)
{
	if (enter_mode||rot_mode||scale_mode||m_mode) return;
	str_cpy(save_dir,cfg_dir);max_st=txt_load(sel_strings,textfile);
	strings_sel(0,info);if (!is(choose_string,VISIBLE)) return;
	while(!select_finish) wait(1);if (select_finish==2) return;
	str_cpy(dest,(sel_strings.pstring)[select_pos-1]);
}

function change_sky_box ()
{
	if (enter_mode||rot_mode||scale_mode||m_mode) return;
	max_st = 0;str_cpy(save_dir,work_dir);
	add_files_to_strings("*.tga");add_files_to_strings("*.png");
	add_files_to_strings("*.jpg");add_files_to_strings("*.mdl");
	strings_sel(0,"Change Sky Box");if (!is(choose_string,VISIBLE)) return;
	while(!select_finish) wait(1);if (select_finish==2) return;
	str_cpy(sky_name,(sel_strings.pstring)[select_pos-1]);
}

function load_info_from_txt(STRING* _action,STRING* addname,TEXT* dest)
{
	STRING* add = "add";str_cpy(save_dir,cfg_dir);
	str_cpy(add,_action);str_cat(add,"_");str_cat(add,addname);str_cat(add,".txt");
	var fileopen = file_open_read (add); 
	if (!fileopen) return(1);
	txt_load(dest,add);
	file_close(fileopen);
	return(0);
}
function help_update ()
{
	if (select==NULL) return;str_cpy(save_dir,cfg_dir);
	if (file_exist (nulltxtfile))
		{txt_load(flags_text_info,nulltxtfile);txt_load(skills_text_info,nulltxtfile);}
	load_info_from_txt(ph_obj[select.id]._action,"flags",flags_text_info); 
	load_info_from_txt(ph_obj[select.id]._action,"skills",skills_text_info); 
}

void load_def_ent ()
{
	ENTITY* ent;
	reg_obj ("ground_n.hmp",vector(0,0,-200),MAP_OBJ);
}


function save_panel_click (var num, PANEL* panel)
{
	if (rot_mode||scale_mode||m_mode||enter_mode) return;
	STRING* st="#20";
	STRING* old="#20";
	str_cpy(save_dir,cfg_dir);
	if (num==1)
	{
		select=NULL;select_sec=NULL;
		loading_level=1;level_load("");obj_num=0;wait(2);level_now();loading_level=0;
		load_def_ent();
	}
	if (num==2) save_file_ent(fileopen);
	if (num==3) 
	{
		str_cpy(st,fileopen);str_trunc(st,4);str_cpy(old,st);
		string_in(st,"Save as");
		while (is(st_in,VISIBLE)) wait(1);
		if (str_cmpi(st,old)) return;
		str_cat(st,".ent");save_file_ent(st);str_cpy(fileopen,st);
	}
	if (num==4) 
	{
		str_cpy(st,obj_dir);str_cat(st,"\\*.ent");
		max_st=txt_for_dir(sel_strings,st);
		strings_sel(0,"Save over");if (!is(choose_string,VISIBLE)) return;
		while(!select_finish) wait(1);if (select_finish==2) return;
		str_cpy(fileopen,(sel_strings.pstring)[select_pos-1]);
		save_file_ent(fileopen);
	}
	if (num==5) 
	{
		str_cpy(st,obj_dir);str_cat(st,"\\*.ent");
		max_st=txt_for_dir(sel_strings,st);
		strings_sel(0,"Open file");if (!is(choose_string,VISIBLE)) {if (ph_prev_mode) enter_mode=1;return;}
		while(!select_finish) wait(1);if (select_finish==2) {if (ph_prev_mode) enter_mode=1;return;}
		str_cpy(fileopen,(sel_strings.pstring)[select_pos-1]);
		load_file_ent(fileopen);
	}
}

function get_bone_from_sel ()
{
	if (rot_mode||scale_mode||m_mode||enter_mode||select==NULL||select_sec==NULL) return;
	str_cpy(ph_obj[select.id].add_ent,ph_obj[select_sec.id].name);
	var bnum = ent_bones (select_sec);
	var count;
	if (bnum == 0) return;
	for (count=1;count<=bnum;count++) ent_boneparent(select_sec,(sel_strings.pstring)[count-1],count);
	max_st=count-1;strings_sel(0,"Chose bone");if (!is(choose_string,VISIBLE)) return;
	if (a_translucent) set(select_sec,TRANSLUCENT);
	while(!select_finish) {draw_all_bones(select_sec);wait(1);}if (select_finish==2) return;
	str_cpy(ph_obj[select.id].bone1,(sel_strings.pstring)[select_pos-1]);
}

function entbone_clone (STRING* add_ent,STRING* bone)
{
	ENTITY* ent = ent_next(NULL);
	while (ent!=NULL)
	{
		if (ent.ph==1) 
		if (str_cmpi(ph_obj[ent.id].add_ent,add_ent)&&str_cmpi(ph_obj[ent.id].bone1,bone)) return(1);
		ent=ent_next(ent);
	}
	return(0);
}

function create_obj_in_bone ()
{
	VECTOR tmp;
	ENTITY* old_sel=select;
	if (rot_mode||scale_mode||m_mode||enter_mode||select==NULL) return;
	var bnum = ent_bones (select);
	var count;
	if (bnum == 0) return;
	for (count=1;count<=bnum;count++) ent_boneparent(select,(sel_strings.pstring)[count-1],count);
	max_st=count-1;strings_sel(0,"Create entity in bone");if (!is(choose_string,VISIBLE)) return;
	if (a_translucent) set(select,TRANSLUCENT);
	while(!select_finish) {draw_all_bones(select);wait(1);}if (select_finish==2) return;
	vec_for_bone(tmp,select,(sel_strings.pstring)[select_pos-1]);
	if (entbone_clone(ph_obj[select.id].name,(sel_strings.pstring)[select_pos-1])) return;
	if (a_box_sphere) you = reg_obj("ph_box.mdl",tmp,BOX); else you = reg_obj("ph_sphere.mdl",tmp,SPHERE);
	if (you==NULL) return;
	str_cpy(ph_obj[you.id].add_ent,ph_obj[select.id].name);
	str_cpy(ph_obj[you.id].bone1,(sel_strings.pstring)[select_pos-1]);
	if (a_translucent) set(you,TRANSLUCENT);
	select = old_sel;
}

function add_box()
{
	if (enter_mode||rot_mode||scale_mode||m_mode) return;VECTOR tmp;
	get_create_pos(tmp);	
	select = reg_obj("ph_box.mdl",tmp,BOX);if (select==NULL) return;
	obj_move(select);
}
function add_sphere()
{
	if (enter_mode||rot_mode||scale_mode||m_mode) return;VECTOR tmp;
	get_create_pos(tmp);	
	select = reg_obj("ph_sphere.mdl",tmp,SPHERE);if (select==NULL) return;
	obj_move(select);
}
function create_map_obj ()
{
	if (enter_mode||rot_mode||scale_mode||m_mode) return;
	VECTOR tmp;get_create_pos(tmp);	
	select = reg_obj("map_obj.mdl",tmp,MAP_OBJ);if (select==NULL) return;
	obj_move(select);
}
function toggle_screen()
{
	if(video_mode==7)
	{
		video_switch (8,32,1);
	}
	else
	{
		video_switch (7,32,2);
	}
}

function help_constrain ()
{

	pan_setpos(show_phinfo,5,1,vector(0,80,0));pan_setpos(show_phinfo,5,2,vector(0,80,0));
	pan_setpos(show_phinfo,5,3,vector(0,80,0));pan_setpos(show_phinfo,5,4,vector(0,80,0));
	pan_setpos(show_phinfo,5,5,vector(0,80,0));
	if (ph_obj[select.id].const_type==1) 
	{
		pan_setpos(show_phinfo,5,1,vector(0,80,0));
		pan_setpos(show_phinfo,5,2,vector(0,90,0));
		pan_setpos(show_phinfo,5,3,vector(0,110,0));
	}
	if (ph_obj[select.id].const_type==2) pan_setpos(show_phinfo,5,1,vector(0,80,0));
	if (ph_obj[select.id].const_type==3)
	{
		pan_setpos(show_phinfo,5,1,vector(0,80,0));
		pan_setpos(show_phinfo,5,2,vector(0,90,0));
		pan_setpos(show_phinfo,5,3,vector(0,100,0));
		pan_setpos(show_phinfo,5,4,vector(0,110,0));
		pan_setpos(show_phinfo,5,5,vector(0,130,0));
	} 
	if (ph_obj[select.id].const_type==4) 
	{
		pan_setpos(show_phinfo,5,1,vector(0,80,0));
		pan_setpos(show_phinfo,5,2,vector(0,110,0));
	}
 
}

function obj_move_event() {if (enter_mode||select==NULL) return; obj_move(select);}
function obj_scale_event() {if (enter_mode||select==NULL) return; obj_scale(select);}
function obj_rotate_event() {if (enter_mode||select==NULL) return; obj_rotate(select);}
function ph_del() {if (enter_mode||select==NULL) return; del_obj(select);}
function toggle_help_event() {toggle(f1helptext,VISIBLE);}
function ent_kick_event() {if (select!=NULL) kick_ent(select);}

function obj_paste_event() 
{
	VECTOR pos;
	if (id_copy>=obj_num) {beep();beep();}
	if (id_copy>=obj_num||m_mode||scale_mode||rot_mode||enter_mode) return;
	get_create_pos (pos);
	you = reg_copy(id_copy,pos);
	copy_ent_prop(you,find_ent_id(id_copy),0);
	select = you; obj_move(select);
}

function set_vis_panels ()
{
	if (prop_panels==2) set(ent_skills_panel,VISIBLE); else reset(ent_skills_panel,VISIBLE);
	if (prop_panels==3) set(ent_flags_panel,VISIBLE); else reset(ent_flags_panel,VISIBLE);
	if (prop_panels==4) set(sliders_step,VISIBLE); else reset(sliders_step,VISIBLE);
	if (prop_panels==5&&!ph_prev_mode) set(save_panel,VISIBLE); else reset(save_panel,VISIBLE);
	if (prop_panels==4)
	{
		move_step = integer (move_step);
		scale_step = integer (scale_step);
		rot_step = integer (rot_step);
	}
	button_state(choose_panel,prop_panels,1);reset(ent_type_panel,VISIBLE);
	if (select==NULL) {reset(ent_skills_panel,VISIBLE);reset(ent_flags_panel,VISIBLE);}
	if (select==NULL) reset(show_phinfo,VISIBLE); else set(show_phinfo,VISIBLE);
	
	if (!a_draw_wireframe) {set(w_select,INVISIBLE);set(w_select_sec,INVISIBLE);} 
		else select_wireframe();

	if is(ent_skills_panel,VISIBLE) set(skills_text_info,VISIBLE); else reset(skills_text_info,VISIBLE);
	if is(ent_flags_panel,VISIBLE) set(flags_text_info,VISIBLE); else reset(flags_text_info,VISIBLE);
	reset(show_info,VISIBLE);/// main info panel
	if (select==NULL) return;/// ***************
	
	button_state(ent_type_panel,ph_obj[select.id].obj_type+1,1);
	button_state(show_phinfo,13+ph_obj[select.id].const_type,1);
	if (prop_panels==3) get_ent_flags();

	if (ph_prev_mode) {reset(show_phinfo,VISIBLE);reset(show_info,VISIBLE);return;}
	set(show_info,VISIBLE);set(ent_type_panel,VISIBLE);
	if (ph_obj[select.id].obj_type<2) reset(show_phinfo,VISIBLE); else set(show_phinfo,VISIBLE);
}

function open_cfg ()
{
	var count=0;
	TEXT* temp = {strings=1;}
	str_cpy(save_dir,cfg_dir);// set save dir
	if (file_exist(entity_dir_cfg)) max_dirs = txt_load(work_dirs,entity_dir_cfg);
	for (count=0;count<max_dirs;count++) add_folder((work_dirs.pstring)[count]);
	if (file_exist(save_dir_cfg)) {if (txt_load(temp,save_dir_cfg)) str_cpy(obj_dir,(temp.pstring)[0]);}
	if (file_exist("editor_help.txt")) txt_load(f1helptext,"editor_help.txt");
	
	var file_handle=file_open_read("config.cfg"); 
	if (file_handle==0) return(0);
	file_str_read (file_handle,sky_name);
	env_flag2 = file_var_read (file_handle);env_flag_sky = file_var_read (file_handle);
	env_layer = file_var_read (file_handle);
	load_vector(file_handle,env_sun);load_vector(file_handle,env_sky_col);
	load_vector(file_handle,env_fog_color);load_vector(file_handle,env_fog_draw);
	load_vector(file_handle,env_shadow);load_vector(file_handle,env_shadow);
	load_vector(file_handle,world_g);
	a_translucent = file_var_read(file_handle);a_fix = file_var_read (file_handle);
	a_unt_set = file_var_read (file_handle);a_first_fun = file_var_read (file_handle);
	a_draw_anchor = file_var_read (file_handle);a_draw_wireframe = file_var_read (file_handle);
	a_scale_entbone = file_var_read (file_handle);a_kick_power = file_var_read(file_handle);
	draw_s_axis = file_var_read (file_handle);a_set_sky = file_var_read (file_handle);
	a_box_sphere = file_var_read (file_handle);move_group = file_var_read (file_handle);
	scale_group = file_var_read (file_handle);rot_group = file_var_read (file_handle);
	move_step = file_var_read (file_handle);scale_step = file_var_read (file_handle);
	rot_step = file_var_read (file_handle);cam_moving_speed = file_var_read (file_handle);
}

function save_cfg ()
{
	str_cpy(save_dir,cfg_dir);file_delete ("preview.pre");
	var file_handle=file_open_write("config.cfg"); 
	if (file_handle==0) sys_exit(0);
	file_str_write (file_handle,sky_name);file_str_write (file_handle,",");
	file_var_write (file_handle,env_flag2);file_var_write (file_handle,env_flag_sky);
	file_var_write (file_handle,env_layer);
	save_vector(file_handle,env_sun);save_vector(file_handle,env_sky_col);
	save_vector(file_handle,env_fog_color);save_vector(file_handle,env_fog_draw);
	save_vector(file_handle,env_shadow);save_vector(file_handle,env_shadow);
	save_vector(file_handle,world_g);
	file_var_write (file_handle,a_translucent);file_var_write (file_handle,a_fix);
	file_var_write (file_handle,a_unt_set);file_var_write (file_handle,a_first_fun);
	file_var_write (file_handle,a_draw_anchor);file_var_write (file_handle,a_draw_wireframe);
	file_var_write (file_handle,a_scale_entbone);file_var_write (file_handle,a_kick_power);
	file_var_write (file_handle,draw_s_axis);file_var_write (file_handle,a_set_sky);
	file_var_write (file_handle,a_box_sphere);file_var_write (file_handle,move_group);
	file_var_write (file_handle,scale_group);file_var_write (file_handle,rot_group);
	file_var_write (file_handle,move_step);file_var_write (file_handle,scale_step);
	file_var_write (file_handle,rot_step);file_var_write (file_handle,cam_moving_speed);
	sys_exit(0);
}
VECTOR old_res;
function change_res ()
{
	if (!vec_dist(old_res,vector(screen_size.x,screen_size.y,0)))  return;
	vec_set(old_res,vector(screen_size.x,screen_size.y,0));
	var screen_scale=maxv(screen_size.x/800,1);
	
	show_info.scale_x =screen_scale;show_info.scale_y =screen_scale;
	show_phinfo.scale_x =screen_scale;show_phinfo.scale_y =screen_scale;
	//ent_type_panel.scale_x =screen_scale;ent_type_panel.scale_y =screen_scale;
	//ent_skills_panel.scale_x=screen_scale;ent_skills_panel.scale_y=screen_scale;
	prev_panel.scale_x=screen_scale;prev_panel.scale_y=screen_scale;
	ph_prop.scale_x=screen_scale;ph_prop.scale_y=screen_scale;
	

	ent_flags_panel.scale_x= screen_scale;ent_flags_panel.scale_y= screen_scale;
	env_panel.scale_x=screen_scale;env_panel.scale_y=screen_scale;
	
	choose_panel.pos_x = screen_size.x-420;
	
	ent_skills_panel.pos_x = screen_size.x-350*ent_skills_panel.scale_x;
	ent_flags_panel.pos_x = screen_size.x - 250*ent_flags_panel.scale_x;
	
	flags_text_info.pos_x=screen_size.x - 250*ent_flags_panel.scale_x;
	flags_text_info.pos_y=screen_size.y - 380*ent_flags_panel.scale_y;
	
	skills_text_info.pos_x=screen_size.x - 350*ent_skills_panel.scale_x;
	//skills_text_info.pos_y=screen_size.y - 380*ent_skills_panel.scale_y;
	
	ent_type_panel.pos_x = screen_size.x-300*ent_type_panel.scale_x;
	ent_type_panel.pos_y = screen_size.y-40*ent_type_panel.scale_y;
	sliders_step.pos_x = screen_size.x - 300*sliders_step.scale_x;
	save_panel.pos_x = screen_size.x - 150*save_panel.scale_x;
	prev_panel.pos_y = screen_size.y-96*prev_panel.scale_y;
	show_phinfo.pos_y = screen_size.y - 220*show_phinfo.scale_y;
	show_info.pos_y = screen_size.y - 330*show_info.scale_y;

	constrain_panel.pos_x = (screen_size.x/2)- (384/2);
	constrain_panel.pos_y = (screen_size.y/2)- (256/2);
	
	env_panel.pos_x =  (screen_size.x/2)-(384/2)*env_panel.scale_x;
	env_panel.pos_y =  (screen_size.y/2)-(416/2)*env_panel.scale_y;

	st_in.pos_x = (screen_size.x/2)-(512/2);st_in.pos_y = (screen_size.y/2)-(128/2);
	vec_in.pos_x = (screen_size.x/2)-(512/2);vec_in.pos_y = (screen_size.y/2)-(128/2);
	
	ph_prop.pos_x = (screen_size.x/2)- (384/2)*ph_prop.scale_x;
	ph_prop.pos_y = (screen_size.y/2)- (256/2)*ph_prop.scale_y;
	
	group_panel.pos_x = (screen_size.x/2)-(384/2);group_panel.pos_y = (screen_size.y/2)-(416/2);

}


function cam_move ()
{
	VECTOR tmp;
	while(1) 
	{
		vec_set(tmp, vector((key_w-key_s)*time_step*cam_moving_speed,(key_a-key_d)*time_step*cam_moving_speed,0));
		vec_rotate(tmp, camera.pan);
		vec_add(camera.x,tmp.x);
		if (mouse_right) vec_add(camera.pan,vector(-mouse_force.x*time_step*20,mouse_force.y*time_step*20,0));
		wait(1);
	}
}

function main()
{

	str_cpy(save_dir,obj_dir);// set save dir
	vec_set(env_sun,vector(50,0,30));vec_set(env_fog_color,nullvector);
	vec_set(env_fog_draw,vector(100,100,0));vec_set(env_shadow,vector(50,1,0));
	vec_set(env_sky_col,vector(128,0,0));vec_set(world_g,vector(0,0,-386));
	vec_set(world_g,vector(0,0,-386));
	open_cfg ();
	button_state(sliders_step,1,move_group);button_state(sliders_step,2,scale_group);
	button_state(sliders_step,3,rot_group);button_state(sliders_step,4,a_draw_anchor);
	button_state(sliders_step,5,a_draw_wireframe);button_state(sliders_step,6,draw_s_axis);
	button_state(sliders_step,7,a_translucent);button_state(sliders_step,8,a_fix);
	button_state(sliders_step,9,a_unt_set);button_state(sliders_step,10,a_box_sphere);
	button_state(sliders_step,11,a_scale_entbone);button_state(sliders_step,12,a_set_sky);
	if (a_first_fun) set(intro_panel,VISIBLE);
	//if (a_first_fun) set(intro_info,VISIBLE);
	
	fps_max = 50;
	shadow_stencil = 1; 
	sun_light = 50;
	d3d_entsort = 2;
	preload_mode = 3;
	
	level_load("");wait(2);level_now();change_res ();
	load_def_ent();video_switch(7,32,0);//wait(-1);
	ph_setgravity (world_g); // set the gravity

	mouse_mode = 4;
	mouse_range = 1000000;
	mouse_map = mouse_p;
	set_env_panel();
	cam_move();
	
	on_close = save_cfg;
	on_i = add_box;
	on_o = add_sphere;
	on_del = ph_del;
	on_m = obj_move_event;
	on_b = obj_scale_event;
	on_r = obj_rotate_event;
	on_esc = NULL;
	on_mouse_left = mouse_left_event;
	on_f1 = toggle_help_event;
	on_f2 = NULL;
	on_f3 = NULL;
	on_f5 = toggle_screen;
	on_f10 = save_cfg;
	on_space = ent_kick_event;
	on_u = create_obj_in_bone;
	on_bksl = add_models;
	on_t = create_map_obj;
	
	on_l = env_panel_enter;
	
	on_cur = go_right;
	on_cul = go_left;
	on_cuu = go_up;
	on_cud = go_down;
	on_home = cam_axis_z;
	on_end = cam_axis_y;
	on_pgdn = cam_axis_x;
	on_tab = prev_mode;
	on_comma = set_vis_to_all;
	on_period = hide_ginvisible;
	on_slash = auto_set_ginvisible;
	on_0 = NULL;
	
	while (1) 
	{

		draw_anchor=0;
		change_res ();
		if (key_1) prop_panels=1;if (key_2) prop_panels=2;
		if (key_3) prop_panels=3;if (key_4) prop_panels=4;if (key_5) prop_panels=5;
		
		if (key_f2) save_panel_click (2,NULL);
		if (key_f3) save_panel_click (3,NULL);
		if (key_f4) save_panel_click (5,NULL);
		
		if (key_p) set_ph_panel();
		if (key_alt) draw_all_const ();
		
		if (key_g) get_bone_from_sel();
		
		if (key_n) select_by_name();
		if (key_v&&key_ctrl) obj_paste_event();
		if ((!rot_mode&&!enter_mode&&!scale_mode&!m_mode)&&key_c&&!key_ctrl) active_const_panel();
		if (key_ctrl&&key_c&&select!=NULL) id_copy=select.id;
		
		//if (select==NULL) reset(show_phinfo,VISIBLE); else set(show_phinfo,VISIBLE);
		
		if (select!=NULL&&!ph_prev_mode) 
		{
			proc_mode = PROC_LATE;
			str_cpy(info_name,ph_obj[select.id].name);
			str_cpy(info_add_ent,ph_obj[select.id].add_ent);
			str_cpy(info_bone1,ph_obj[select.id].bone1);
			str_cpy(info_bone2,ph_obj[select.id].bone2);
			str_cpy(info_filename,ph_obj[select.id].file);
			str_cpy(info_constrain,ph_obj[select.id].constrain);
			//
			if (!str_cmpi(info_action,ph_obj[select.id]._action)) help_update();
			str_cpy(info_action,ph_obj[select.id]._action);
			str_cpy(info_material,ph_obj[select.id]._material);
			//
			vec_set(info_pos,select.x);vec_set(info_angle,select.pan);
			vec_set(info_ph_maxs,ph_obj[select.id].ph_maxs);
			vec_set(info_ph_mass,ph_obj[select.id].ph_mass);
			vec_set(info_ph_elast,ph_obj[select.id].ph_elast);
			vec_set(info_phcon_p1,ph_obj[select.id].phcon_p1);
			vec_set(info_phcon_p2,ph_obj[select.id].phcon_p2);
			vec_set(info_phcon_p3,ph_obj[select.id].phcon_p3);
			vec_set(info_phcon_p4,ph_obj[select.id].phcon_p4);
			vec_set(info_phcon_p5,ph_obj[select.id].phcon_p5);
			vec_set(info_phcon_p6,ph_obj[select.id].phcon_p6);
			vec_set(info_phcon_mot1,ph_obj[select.id].phcon_mot1);
			vec_set(info_phcon_mot2,ph_obj[select.id].phcon_mot2);
			info_const_type=ph_obj[select.id].const_type;info_egroup = ph_obj[select.id].s_param.z;
			//
			info_scale.x=select.scale_x;info_scale.y=select.scale_y;info_scale.z=select.scale_z;
			info_obj_type = ph_obj[select.id].obj_type;
			player = select;
			info_id = select.id;
			if (ph_obj[select.id].const_type<=4&&ph_obj[select.id].const_type!=0) draw_anchor=1;
			if (prev_constrain!=ph_obj[select.id].const_type) {help_constrain();prev_constrain=ph_obj[select.id].const_type;}
			
			if (key_7&&draw_anchor&&ph_obj[select.id].const_type==4) rotate_const_axis (ph_obj[select.id].phcon_p1);
			if (key_8&&draw_anchor&&(ph_obj[select.id].const_type==2||ph_obj[select.id].const_type==3)) 
				rotate_const_axis (ph_obj[select.id].phcon_p2);
			if (key_9&&draw_anchor&&ph_obj[select.id].const_type==3) rotate_const_axis (ph_obj[select.id].phcon_p3);
			if (key_h) auto_set_const_type(select);
			if (key_f)  set_ents_to_bone (select);
			if (key_q&&!key_shift) var_enter(ph_obj[select.id].s_param.z,"Enter entity group. 0 = without group ");
			if (key_q&&key_shift) group_panel_a();
			
			draw_bounding_box(select,vector(0,200,20));
			if (!enter_mode&&!scale_mode&&draw_s_axis) draw_axis_info (select,nullvector,10,"X","Y","Z",vector(200,200,0));
			if (key_equals&&ph_obj[select.id].const_type<=3) vec_set(ph_obj[select.id].phcon_p1,select.x);
			if (key_0&&draw_anchor) move_anchor(select);
			
			if (select_sec!=NULL) 
			{
				draw_bounding_box(select_sec,vector(200,200,200));
				if (key_e) str_cpy(ph_obj[select.id].constrain,ph_obj[select_sec.id].name);
				if (key_brackr&&draw_anchor) vec_set(ph_obj[select.id].phcon_p1,select_sec.x);
			}
		}
		
		if (select!=NULL&&ph_prev_mode) 
		{
			draw_bounding_box(select,vector(0,200,20));
			if (key_x&&select.phtype) phent_addvelcentral(select,vector(0,0,a_kick_power*time_step));
			if (key_c&&select.phtype) ent_kick_event();
		}
		set_vis_panels ();	
		ent_proc();
		wait(1);
	}
	
}