#define const_mode skill50
#define const_id skill51
#define const_ent skill52
#define phtype skill40

function kick_ent(ENTITY* this)
{
	if (!this.phtype) return;
	VECTOR vKick;
	vec_set(vKick,vector(a_kick_power*time_step,0,0));
	vec_rotate(vKick,camera.pan);
	phent_addvelcentral(this,vKick);
}

function set_ph_ents ()
{
	ENTITY* ent=ent_next(NULL);
	var tvar;
	while(ent!=NULL)
	{
		ent.phtype=0;
		if (ent.ph==1) {
		if (ph_obj[ent.id].obj_type==BOX) {phent_settype(ent,PH_RIGID,PH_BOX);ent.phtype=BOX;}
		if (ph_obj[ent.id].obj_type==SPHERE) {phent_settype(ent,PH_RIGID,PH_SPHERE);ent.phtype=SPHERE;}
		if (ph_obj[ent.id].obj_type==CYLINDER) {phent_settype(ent,PH_RIGID,PH_CYLINDER);ent.phtype=CYLINDER;}
		if (ph_obj[ent.id].obj_type==POLY) {phent_settype(ent,PH_RIGID,PH_POLY);ent.phtype=POLY;}
		
		if (ent.phtype) 
		{
			phent_setmass (ent,ph_obj[ent.id].ph_mass.x,PH_SPHERE);
			phent_setdamping(ent,ph_obj[ent.id].ph_mass.y,ph_obj[ent.id].ph_mass.z);
			phent_setelasticity(ent,ph_obj[ent.id].ph_elast.x,ph_obj[ent.id].ph_elast.y);
			phent_setfriction (ent,ph_obj[ent.id].ph_elast.z);
			if (vec_length(ph_obj[ent.id].ph_maxs)) phent_setmaxspeed(ent,ph_obj[ent.id].ph_maxs.x,ph_obj[ent.id].ph_maxs.y);
		}
		}
		ent=ent_next(ent);
	}
}

function set_const_ents ()
{
	
	ENTITY* ent=ent_next(NULL);
	ENTITY* ent1;
	ENTITY* ent2;
	var tvar;
	VECTOR tmp;
	while(ent!=NULL)
	{
		if (ent.ph==1) if (ent.phtype||ph_obj[ent.id].obj_type==2)
		{
			ent.const_mode=0;you=find_by_name(ph_obj[ent.id].constrain);ent1=ent;ent2=you; 
			if (ph_obj[ent.id].obj_type==2) ent1=find_by_name(ph_obj[ent.id].bone2);
			if (ent1==NULL) ph_obj[ent.id].const_type=0;
			if (ent1!=NULL) if (!ent1.phtype) ph_obj[ent.id].const_type=0;
			//
			if (ph_obj[ent.id].s_param.y&&you!=NULL) if (you.phtype){ent2=ent1;ent1=you;}
			if (ph_obj[ent.id].const_type==1) {ent.const_id=phcon_add(PH_HINGE,ent1,ent2);ent.const_mode=1;}
			if (ph_obj[ent.id].const_type==2) {ent.const_id=phcon_add(PH_BALL,ent1,ent2);ent.const_mode=2;}
			if (ph_obj[ent.id].const_type==3) {ent.const_id=phcon_add(PH_WHEEL,ent1,ent2);ent.const_mode=3;}
			if (ph_obj[ent.id].const_type==4) {ent.const_id=phcon_add(PH_SLIDER,ent1,ent2);ent.const_mode=4;}
			
			
			if (ent.const_id) {
			if (vec_length(ph_obj[ent.id].phcon_p1)||you==NULL) {vec_set(tmp,ph_obj[ent.id].phcon_p1);} else
			{	
				vec_set(tmp,ent1.x);vec_sub(tmp,ent2.x);
				vec_scale(tmp,0.5);vec_add(tmp,ent2.x);
			}
			if (!vec_length(ph_obj[ent.id].phcon_p1)&&you==NULL) vec_set(tmp,ent1.x);
			phcon_setparams1 (ent.const_id,tmp,ph_obj[ent.id].phcon_p2,ph_obj[ent.id].phcon_p3);
			phcon_setparams2 (ent.const_id,ph_obj[ent.id].phcon_p4,ph_obj[ent.id].phcon_p5,ph_obj[ent.id].phcon_p6);
			phcon_setmotor (ent.const_id,ph_obj[ent.id].phcon_mot1,ph_obj[ent.id].phcon_mot2,nullvector);
			}
		}
		ent=ent_next(ent);
	}
}


function attach_bones (ENTITY* this)
{
	var b_count=0; //count of attach bone to ent
	var ent_num=0;
	var index;
	var attach_ent[100]; //up to 100 bones, attach_ent 
	var sort_ent[100]; 
	var b_priority[100]; //need for sorting ents
	var max_priority=0; //need for sorting ents
	var priority=0; //need for sorting ents
	var old_angle[300]; //vector
	VECTOR b_pos;
	VECTOR b_move;
	VECTOR b_ang;
	VECTOR b_ang1;
	ENTITY* ent = ent_next (NULL);
	var debug=0;
	
	while (ent!=NULL)
	{
		if (ent.ph==1)
		{
			if (str_cmpi(ph_obj[ent.id].add_ent,ph_obj[this.id].name)) 
			{
				if (index=get_bone_index(this,ph_obj[ent.id].bone1)) 
				{
					attach_ent[b_count]=handle(ent);//
					b_priority[b_count]=get_count_of_parent(this,index);//set bone priotity
					if (max_priority<b_priority[b_count]) {max_priority=b_priority[b_count];}
					b_count++;
				} 
			}
		} 
		ent=ent_next(ent);
	}

	// sort ent by bones parent
	index=0;while (priority<=max_priority) 
	{
		ent_num=0;
		while(ent_num<b_count)
		{
			if (b_priority[ent_num]==priority) {sort_ent[index]=attach_ent[ent_num];index++;}
			ent_num++;
		}
		priority++;
	}
	ent_bonereset_all(this);
	STRING* s_t = "#30";//del this eraly
	VECTOR st_pos; //del this eraly
	while (ph_prev_mode&&this!=NULL&&!loading_level)
	{
		ent_num=0;
		while (ent_num<b_count)
		{
			ent=ptr_for_handle(sort_ent[ent_num]);
			if (ent_num==0&&is(this,FLAG1)) vec_set(this.x,ent.x);
			ent_bonereset(this,ph_obj[ent.id].bone1);
			vec_for_bone(b_pos,this,ph_obj[ent.id].bone1);
			ang_for_bone(b_ang,this,ph_obj[ent.id].bone1);
			vec_set(b_move,ent.x);vec_sub(b_move,b_pos);
			b_move.x/= this.scale_x;b_move.y/= this.scale_y; b_move.z/= this.scale_z; 
			vec_rotateback (b_move,b_ang);///change this pliase
			
			b_ang.x = 360-b_ang.x;b_ang.y = 360-b_ang.y;b_ang.z = 360-b_ang.z;
			vec_set(b_ang1,nullvector);
			ang_add(b_ang1,vector(b_ang.x,0,0));
			ang_add(b_ang1,vector(0,b_ang.y,0));
			ang_add(b_ang1,vector(0,0,b_ang.z));
			ang_rotate(b_ang1,ent.pan);
			ent_bonerotate(this,ph_obj[ent.id].bone1,b_ang1);
			ent_bonemove(this,ph_obj[ent.id].bone1,b_move);	
			ent_num++;
		}
		ent_num=0;
		while (ent_num<b_count&&debug) //debug
		{
			ent=ptr_for_handle(sort_ent[ent_num]);
			vec_for_bone(b_pos,this,ph_obj[ent.id].bone1);
			ang_for_bone(b_ang,this,ph_obj[ent.id].bone1);
			draw_box(b_pos,bone_size,vector(0,0,255));
			draw_angle(b_pos,b_ang,5,vector(0,0,255));
			vec_set(st_pos,b_pos);vec_to_screen(st_pos,camera);
			str_for_num(s_t,ent_num);str_cat(s_t,";");
			str_cat(s_t,str_for_num(NULL,get_count_of_parent(this,get_bone_index(this,ph_obj[ent.id].bone1))));
			draw_text(s_t,st_pos.x,st_pos.y,vector(0,0,255));
			ent_num++;
		}
		ent_num=0;
		wait(1);
	}
}

function apply_action ()
{
	ENTITY* ent=ent_next(NULL);
	while (ent!=NULL)
	{
		if (ent.ph==1)
		{
			if (str_cmpi(ph_obj[ent.id]._action,"attach_ent_bones")) attach_bones (ent);
		}
		ent = ent_next(ent);
	}
	
}

function make_phents ()
{
	set_ph_ents();set_const_ents();apply_action();
}

function prev_mode ()
{
	if ((rot_mode||scale_mode||enter_mode||m_mode)&&!ph_prev_mode) return;
	if (ph_prev_mode) 
	{
		set(prev_text,VISIBLE);enter_mode=0;
		vec_set(cam_pos,camera.x);vec_set(cam_ang,camera.pan);
		vec_set(sky_color,nullvector);
		load_file_ent ("preview.pre");vec_set(camera.x,cam_pos);vec_set(camera.pan,cam_ang);
		wait(3);ph_prev_mode=0;
		if (!a_set_sky) vec_set(sky_color,vector(128,0,0));
		reset(prev_panel,VISIBLE);reset(prev_text,VISIBLE);
		reset(intro_prev_info,VISIBLE);
	}
	else
	{ 
		set(intro_prev_info,VISIBLE);
		ph_prev_mode=1;set(prev_panel,VISIBLE);
		save_file_ent("preview.pre");ph_setgravity (world_g); // set the gravity
		make_phents();select=NULL;enter_mode=1;
	}
}