
MATERIAL* mtl_wireframe =
{
effect=
"
technique wireframe
{
	pass p0
	{
		fillmode = wireframe;
	}
}";
}

action change_color ()
{
	set(my,LIGHT);
	while (my!=NULL)
	{
		if (my.skill1) my.skill2-=time_step*50; else my.skill2+=time_step*50;
		if (my.skill2>254) {my.skill1=1;my.skill2=255;}
		if (my.skill2<0) {my.skill1=0;my.skill2=0;}
		my.red=255;my.blue=my.skill2;my.green=my.skill2;
		wait(1);
	}
}

function load_env ()
{
	while (ph_prev_mode) wait(1);

	if (!str_cmpi(sky_name,"")&&!str_cmpi(sky_name,"None")) load_layer_ent();
	sun_light=env_sun.x;sun_angle.pan=env_sun.y;sun_angle.tilt=env_sun.z;
	vec_set(d3d_fogcolor1,env_fog_color);
	camera.fog_start = env_fog_draw.x;camera.fog_end = env_fog_draw.y;
	fog_color = env_fog_draw.z;
	mat_shadow.alpha = env_shadow.x;shadow_stencil = env_shadow.y;
	vec_set(sky_color,env_sky_col);

}

function level_now() //this call need after level_load function
{
	load_env ();
	w_select=ent_create(NULL,nullvector,NULL);
	w_select_sec=ent_create(NULL,nullvector,NULL);
	anchor=ent_create("anchor.mdl",nullvector,change_color);
	anchor.flags2 |= UNTOUCHABLE;set(anchor,PASSABLE);
	anchor.ambient = 200;set(anchor,TRANSLUCENT);anchor.alpha = 80;
	
	w_select.material = mtl_wireframe;
	w_select_sec.material = mtl_wireframe;
	w_select.ambient = 200;w_select_sec.ambient = 200;
	w_select.flags2 |= UNTOUCHABLE;w_select_sec.flags2 |= UNTOUCHABLE;
	set(w_select,LIGHT|PASSABLE);set(w_select_sec,PASSABLE);
	w_select.red=0;w_select.blue=0;w_select.green=255;
	
	ph_prev_mode=0;
}


ENTITY* pre_select=NULL;
//ENTITY* pre_s_select=NULL;
function mouse_left_event ()
{
	if ((enter_mode||rot_mode||scale_mode||m_mode)&&!ph_prev_mode) return;
	if (pre_select!=NULL&&a_unt_set) pre_select.flags2 &= ~UNTOUCHABLE;
///if (pre_s_select!=NULL&&a_unt_set) pre_s_select.flags2 &= ~UNTOUCHABLE;
	if  (mouse_left)  select_sec=NULL;

	if (mouse_ent!=NULL&&mouse_left&&!key_shift) 
		if (mouse_ent.ph==1) if (select==mouse_ent) select=NULL; else 
		{
			select = mouse_ent;player=select;
			if (a_unt_set) {select.flags2 |= UNTOUCHABLE;pre_select=select;}
		}


	if (mouse_ent!=NULL&&mouse_left&&key_shift) 
		if (mouse_ent.ph==1) if (select_sec==mouse_ent) select_sec=NULL; else 
		{
			//if (a_unt_set) {select_sec.flags2 |= UNTOUCHABLE;pre_s_select=select_sec;}
			select_sec = mouse_ent;
		}
}

function select_wireframe() 
{
	if (loading_level||!a_draw_wireframe) return;
	STRING* filename1="#30";
	STRING* filename2="#30";
	if (select!=NULL) str_for_entfile(filename1,select);
	if (select_sec!=NULL) str_for_entfile(filename2,select_sec);
	if (!str_cmpi(filename1,str_for_entfile(NULL,w_select))&&select!=NULL) {ent_morph (w_select,filename1);}
	if (!str_cmpi(filename2,str_for_entfile(NULL,w_select_sec))&&select_sec!=NULL) ent_morph (w_select_sec,filename2);

	if (w_select!=NULL&&select!=NULL)
	{
		reset(w_select,INVISIBLE);
		vec_set(w_select.x,select.x);vec_set(w_select.pan,select.pan);
		w_select.scale_x = select.scale_x;
		w_select.scale_y = select.scale_y;
		w_select.scale_z = select.scale_z;
	} else set(w_select,INVISIBLE);
	
	if (w_select_sec!=NULL&&select_sec!=NULL)
	{
		reset(w_select_sec,INVISIBLE);
		vec_set(w_select_sec.x,select_sec.x);vec_set(w_select_sec.pan,select_sec.pan);
		w_select_sec.scale_x = select_sec.scale_x;
		w_select_sec.scale_y = select_sec.scale_y;
		w_select_sec.scale_z = select_sec.scale_z;
	} else set(w_select_sec,INVISIBLE);
	
} 


ENTITY* find_by_name (STRING* st)
{
	ENTITY* ent;
	ent = ent_next(NULL);
	while (ent!=NULL) 
	{
		if (ent.ph==1)
		{
			if (str_cmp(st,ph_obj[ent.id].name)) return(ent);
		}
		ent=ent_next(ent);
	}
	return(NULL);
}

function get_anchor (ENTITY* this,VECTOR* vec)
{
	if (vec_length(ph_obj[select.id].phcon_p1))
	{
		vec_set(vec,ph_obj[select.id].phcon_p1);return;
	}	
	if (ent_const!=NULL)
	{
		vec_set(vec,this.x);vec_sub(vec,ent_const.x);
		vec_scale(vec,0.5);vec_add(vec,ent_const.x);return;
	}
	if (ent_const==NULL)
	{
		vec_set(vec,this.x);
	}
}

function move_anchor (ENTITY* this)
{
	if (select==NULL||rot_mode||scale_mode||m_mode||enter_mode) return;
	VECTOR old_anchor;
	VECTOR old_pos;
	vec_set(old_anchor,ph_obj[select.id].phcon_p1);vec_set(old_pos,anchor.x);
	obj_move(anchor);while (m_mode) {vec_set(ph_obj[select.id].phcon_p1,anchor.x);wait(1);}
	if (vec_length(old_anchor)) vec_set(ph_obj[select.id].phcon_p1,anchor.x); else
	if (old_pos.x==anchor.x&&old_pos.y==anchor.y&&old_pos.z==anchor.z) vec_set(ph_obj[select.id].phcon_p1,nullvector);
	
}

function rotate_const_axis (VECTOR* axis)
{
	VECTOR ax;
	VECTOR an;
	if (select==NULL||rot_mode||scale_mode||m_mode||enter_mode) return;
	vec_to_angle(ax,axis);vec_set(anchor.pan,ax);obj_rotate(anchor);
	while (rot_mode) {vec_set(an,vector(1,0,0));vec_rotate(an,anchor.pan);vec_set(axis,an);wait(1);}
	vec_set(an,vector(1,0,0));vec_rotate(an,anchor.pan);vec_set(axis,an);
	wait(1);vec_set(anchor.pan,nullvector);
}	

function set_ents_to_bone (ENTITY* this)
{
	VECTOR b_pos;
	VECTOR b_ang;
	VECTOR pos;
	ENTITY* ent = ent_next (NULL);
		while (ent!=NULL)
	{
		if (ent.ph==1)
		{
			if (str_cmpi(ph_obj[ent.id].add_ent,ph_obj[this.id].name)) 
			{
				
				if (get_bone_index(this,ph_obj[ent.id].bone1)) 
				{
					vec_for_bone(b_pos,this,ph_obj[ent.id].bone1);
					ang_for_bone(b_ang,this,ph_obj[ent.id].bone1);
					vec_set(ent.x,b_pos);vec_set(ent.pan,b_ang);
				} 
			you = find_by_name(ph_obj[ent.id].constrain);
			if (you!=NULL)
			{
				vec_set(pos,you.x);vec_sub(pos,ent.x);vec_normalize(pos,1);
				vec_add(pos,ent.x);draw_box(pos,1,vector(0,100,200));
				if (ph_obj[ent.id].const_type>0&&ph_obj[ent.id].const_type<=3) 
				{
					vec_set(ph_obj[ent.id].phcon_p1,pos);
				}
			}
			}
		} 
		ent=ent_next(ent);
	}
	
}



function draw_axis_line1 (ENTITY* this) 
{
	VECTOR phang;
	VECTOR eang;
	VECTOR pos;
	VECTOR m_pos;
	VECTOR color;vec_set(color,vector(0,0,200));
	var l_size = 5;
	var parts = 7;
	var cang;var c;var radius=1;
	get_anchor(this,m_pos); 
	vec_set(phang,ph_obj[select.id].phcon_p2);vec_scale(phang,1000);vec_to_angle(eang,phang);
	vec_set(pos,vector(l_size,0,0));vec_rotate(pos,eang);vec_add(pos,m_pos);
	draw_line3d(pos,NULL,100);vec_set(pos,vector(-l_size,0,0));
	vec_rotate(pos,eang);vec_add(pos,m_pos);draw_line3d(pos,color,100);
	if (ph_obj[select.id].s_param.y) if (ent_const!=NULL) if (ph_obj[ent_const.id].obj_type>=3) 
	{
		vec_inverse(phang);vec_to_angle(eang,phang);
	}
	if (caxis_by_radius) radius = maxv(vec_dist(m_pos,this.x),1);
	vec_set(pos,this.x);
	if (vec_dist(m_pos,this.x)<0.5&&ent_const!=NULL) vec_sub(pos,ent_const.x); else vec_sub(pos,m_pos);
	vec_to_angle(phang,pos);
	cang = get_cool_angle (eang,phang);
	for (c=-l_size;c<=l_size;c+=l_size/parts)  
		draw_cycle(m_pos,vector(c,0,0),eang,cang,radius,ph_obj[select.id].phcon_p4,color);
}


function draw_axis_line2 (ENTITY* this) 
{
	VECTOR phang;
	VECTOR eang;
	VECTOR pos;
	VECTOR m_pos;
	VECTOR color;vec_set(color,vector(0,100,200));
	var l_size = 8;
	var parts = 4;var c;
	get_anchor(this,m_pos); 
	vec_set(phang,ph_obj[select.id].phcon_p3);vec_scale(phang,1000);vec_to_angle(eang,phang);
	vec_set(pos,vector(l_size,0,0));vec_rotate(pos,eang);vec_add(pos,m_pos);
	draw_line3d(pos,NULL,100);vec_set(pos,vector(-l_size,0,0));
	vec_rotate(pos,eang);vec_add(pos,m_pos);draw_line3d(pos,color,100);
	for (c=-l_size;c<=l_size;c+=l_size/parts)  
		draw_cycle(m_pos,vector(c,0,0),eang,0,0.2,vector(-180,180,0),color);
}

function draw_slider_const (ENTITY* this,VECTOR* pos)
{
	VECTOR bpos;
	VECTOR epos;
	VECTOR eang;
	vec_to_angle(eang,ph_obj[this.id].phcon_p1);
	vec_set(bpos,vector(ph_obj[this.id].phcon_p4.x,0,0));vec_rotate(bpos,eang);vec_add(bpos,pos);
	vec_set(epos,vector(ph_obj[this.id].phcon_p4.y,0,0));vec_rotate(epos,eang);vec_add(epos,pos);
	draw_constrain_line (bpos,epos,20,vector(100,10,200));
}



function draw_connect_ent (ENTITY* now,ENTITY* con)
{
	VECTOR end_pos;
	var index;
	var bnum = ent_bones(con);
	if (!index=get_bone_index(con,ph_obj[now.id].bone1)) 
	{
		vec_set(end_pos,con.x);
		draw_line3d(now.x,NULL,100);
		draw_line3d(end_pos,vector(200,0,0),100);
		if (vec_to_screen(end_pos,camera)!=NULL) draw_text("bone not found",end_pos.x,end_pos.y,vector(200,0,0)); 
		return;
	}
	vec_for_bone(end_pos,con,ph_obj[now.id].bone1);
	draw_line3d(now.x,NULL,100);
	draw_line3d(end_pos,vector(200,0,0),100);
	if (ent_boneparent(con,NULL,index)==NULL) draw_bone(con,index,vector(0,0,200)); 
		else draw_bone(con,index,vector(200,0,0));
}

function draw_const (ENTITY* this)
{
	
	if (ph_obj[this.id].obj_type<=2||ph_prev_mode) return;
	VECTOR anchor_point;
	if (a_translucent&&ph_obj[this.id].const_type!=0) 
	{
		set(this,TRANSLUCENT);
		if (ent_const!=NULL) {set(ent_const,TRANSLUCENT);reset(ent_const,INVISIBLE);}
	}
	vec_set(anchor_point,nullvector);get_anchor(this,anchor_point);
	if (ph_obj[select.id].const_type==0) 
	{
		if (ent_const!=NULL) {draw_line3d(this.x,NULL,100);draw_line3d(ent_const.x,vector(200,200,100),100);}
		return;
	}
	if (ph_obj[select.id].const_type==1) draw_axis_line1(this); 
	if (ph_obj[select.id].const_type==3) 
	{
		if (ent_const==NULL)  return;
		if (ph_obj[ent_const.id].obj_type<3) 
		{
			vec_set(anchor_point,this.x);
			if (vec_to_screen(anchor_point,camera)!=NULL) 
				draw_text("Constrain error!",anchor_point.x,anchor_point.y,vector(200,200,200)); 
			return;
		}
		draw_axis_line1(this);draw_axis_line2(this);
	}
	if (ph_obj[select.id].const_type==4)
	{
		if (ent_const!=NULL) 
		{
			draw_line3d(this.x,NULL,100);draw_line3d(ent_const.x,vector(200,200,100),100);
			if (ph_obj[select.id].s_param.y&&ph_obj[ent_const.id].obj_type>=3) 
				draw_slider_const (select,ent_const.x); else draw_slider_const (select,this.x);
		} else draw_slider_const (select,this.x);
		reset(anchor,INVISIBLE);vec_set(anchor.x,this.x);return;
	} 
	
	if (ent_const!=NULL) 
	{	
	   	vec_set(anchor_point,nullvector);get_anchor(this,anchor_point);
	   	if (ph_obj[select.id].s_param.y&&ph_obj[ent_const.id].obj_type>=3)
	   	{	   		
	   		draw_constrain_line (ent_const.x,anchor_point,5,vector(200,200,100));
	   		draw_constrain_line (anchor_point,this.x,5,vector(200,200,100));
	   	} 
	   	else
	   	{
	   		draw_constrain_line (this.x,anchor_point,5,vector(200,200,100));
	   		draw_constrain_line (anchor_point,ent_const.x,5,vector(200,200,100));
	   	}
	}  else draw_constrain_line(this.x,anchor_point,10,vector(200,200,100));
	
	if (draw_anchor)
	{
		vec_set(anchor.x,anchor_point);
		if (vec_to_screen(anchor_point,camera)!=NULL&&a_draw_anchor) 
			draw_text("Anchor point",anchor_point.x,anchor_point.y,vector(200,200,200)); 
		reset(anchor,INVISIBLE);
	}	
	
}

function get_near_entbone (ENTITY* this,ENTITY* sor)
{
	ENTITY* ent;
	long b_index=get_bone_index(this,ph_obj[sor.id].bone1);
	while ((b_index=ent_boneparent(this,b_index,0))!=NULL)
	{
		ent=ent_next(NULL);
		while (ent!=NULL)
		{
			if (ent.ph==1) if (str_cmpi(ph_obj[ent.id].add_ent,ph_obj[this.id].name)) 
			{
				if (b_index==get_bone_index(this,ph_obj[ent.id].bone1)) {
					draw_constrain_line (sor.x,ent.x,3,vector(0,255,0));return(ent);}
			}
			ent = ent_next(ent);
		}
	}
	return (NULL);
}

function auto_set_const_type (ENTITY* m_ent)
{
	ENTITY* ent=ent_next(NULL);
	var b_index;
	ENTITY* sel_old = m_ent;
	VECTOR pos;VECTOR eang;
	while (ent!=NULL)
	{
		if (ent.ph==1) if (str_cmpi(ph_obj[ent.id].add_ent,ph_obj[sel_old.id].name))
		{
			if (b_index=get_bone_index(m_ent,ph_obj[ent.id].bone1))
			{
				you = get_near_entbone(m_ent,ent);draw_bounding_box(ent,vector(0,0,200));
				if (you!=NULL) str_cpy(ph_obj[ent.id].constrain,ph_obj[you.id].name);
			} else you=NULL;
			if (you!=NULL)
			{
				vec_set(pos,you.x);vec_sub(pos,ent.x);vec_to_angle(eang,pos);
				vec_set(pos,vector(0,0,1));vec_rotate(pos,vector(eang.x,eang.y,0));
				vec_set(ph_obj[ent.id].phcon_p2,pos);vec_set(ph_obj[ent.id].phcon_p4,vector(-45,45,0));
				vec_set(ph_obj[ent.id].phcon_p3,nullvector);vec_set(ph_obj[ent.id].phcon_p5,nullvector);
				vec_set(ph_obj[ent.id].phcon_p6,nullvector);vec_set(ph_obj[ent.id].phcon_mot1,nullvector);
				vec_set(ph_obj[ent.id].phcon_mot1,nullvector);
				ph_obj[ent.id].const_type = 1;select = ent;ent_const=you;draw_const (select);
			}
		}
		ent = ent_next(ent);
	}
	select = sel_old;
}

function draw_all_const ()
{
	ENTITY* ent=ent_next(NULL);
	ENTITY* sel_old = select;
	ENTITY* prof;
	while (ent!=NULL)
	{
		if (ent.ph==1&&ent!=sel_old)
		{
			if (ph_obj[ent.id].obj_type>1) if (ph_obj[ent.id].obj_type==2) 
			{
				prof=find_by_name(ph_obj[ent.id].bone2);select=ent;
				ent_const=find_by_name(ph_obj[ent.id].constrain);
				if (prof!=NULL) draw_const (prof);
			} else
			{
				select=ent;ent_const=find_by_name(ph_obj[ent.id].constrain);
				draw_const (select);
			}
		}
		ent=ent_next(ent);
	}
	select = sel_old;
}

function ent_proc () 
{
	//this func process all ent, find and draw constrain and other info
	
	VECTOR anchor_point;
	VECTOR text_pos;
	var b_index;
	STRING* draw_st="#30";
	
	
	ENTITY* ent;
	ent_const=NULL;
	ent_attach=NULL;
	ent_prof=NULL;
	
	ent = ent_next(NULL);
	while (ent!=NULL) 
	{
		if (ent.ph==1)
		{
			if ((ent.flags2 & UNTOUCHABLE)&&!a_unt_set)
			{
				vec_set(text_pos,ent.x);
				if (vec_to_screen(text_pos,camera)!=NULL)
				{
					str_cpy(draw_st," ");
					if (ent.flags2 & UNTOUCHABLE)
					{
						str_cat(draw_st,"Name:");str_cat(draw_st,ph_obj[ent.id].name);
						str_cat(draw_st,"; Untouchable; ");
					}
					draw_text(draw_st,text_pos.x,text_pos.y,vector(0,200,0));
				}
			}
			if (key_alt)
			{
				vec_set(text_pos,ent.x);
				if (vec_to_screen(text_pos,camera)!=NULL&&ph_obj[ent.id].obj_type>=2&&ph_obj[ent.id].const_type>=1)
				{
					str_cpy(draw_st," ");str_cat(draw_st,ph_obj[ent.id].name);					
					if (ph_obj[ent.id].const_type==1) str_cat(draw_st,";Hinge");
					if (ph_obj[ent.id].const_type==2) str_cat(draw_st,";Ball");
					if (ph_obj[ent.id].const_type==3) str_cat(draw_st,";Wheel");
					if (ph_obj[ent.id].const_type==4) str_cat(draw_st,";Slider");
					if (ph_obj[ent.id].obj_type>=3)
					draw_text(draw_st,text_pos.x,text_pos.y,vector(12,111,243)); else
					draw_text(draw_st,text_pos.x,text_pos.y,vector(0,0,243));
				}
			}
			
			if (select!=NULL)
			{
				if (ent_const==NULL) if (str_cmp(ph_obj[select.id].constrain,ph_obj[ent.id].name)) ent_const=ent;
				if (ent_attach==NULL) if (str_cmp(ph_obj[select.id].add_ent,ph_obj[ent.id].name)) ent_attach=ent;
				if (ent_prof==NULL) if (str_cmp(ph_obj[select.id].bone2,ph_obj[ent.id].name)) ent_prof=ent;
				if (str_cmpi(ph_obj[select.id].name,ph_obj[ent.id].add_ent)) 
					if (b_index=get_bone_index(select,ph_obj[ent.id].bone1))
					{
						vec_for_bone(text_pos,select,ph_obj[ent.id].bone1);
						draw_line3d(ent.x,NULL,100);draw_line3d(text_pos,vector(200,0,0),100);
						if (ent_boneparent(select,NULL,b_index)==NULL) draw_bone(select,b_index,vector(0,0,200)); 
						else draw_bone(select,b_index,vector(200,0,0));
						if (a_fix) 
						{
							str_cpy(ph_obj[select.id]._action,"attach_ent_bones");
							ph_obj[select.id].obj_type=0;set(select,PASSABLE);
						}
						if (a_translucent)
						{
							if is(ent,VISIBLE) set(ent,TRANSLUCENT);
						}
					}
			}
		}
		ent=ent_next(ent);
	}
	//draw constrain and attach bone
	set(anchor,INVISIBLE);
	if (select==NULL) {return;}	
	if (ent_attach!=NULL) draw_connect_ent (select,ent_attach);	
	if (ph_obj[select.id].obj_type<=1) return; 
	if (ent_prof!=NULL&&ph_obj[select.id].obj_type==2)  draw_const (ent_prof); else
	draw_const (select); 
	
} 

function hide_ginvisible ()
{
	ENTITY* ent=ent_next(NULL);
	while(ent!=NULL)
	{	
		if (ent.ph==1) if (ph_obj[ent.id].s_param.x) set(ent,INVISIBLE);
		ent=ent_next(ent);
	}
}



function set_vis_to_all ()
{
	ENTITY* ent=ent_next(NULL);
	while(ent!=NULL)
	{	
		if (ent.ph==1) reset(ent,INVISIBLE);
		ent=ent_next(ent);
	}
}

function auto_set_ginvisible ()
{
	ENTITY* ent=ent_next(NULL);
	while(ent!=NULL)
	{	
		if (ent.ph==1) 
		{
			you = find_by_name(ph_obj[ent.id].add_ent);
			if (you!=NULL) {ph_obj[ent.id].s_param.x = 1;draw_bounding_box(ent,vector(255,0,255));}
		}
		ent=ent_next(ent);
	}
}


function face_to_select ()
{
	VECTOR eang;
	vec_set(eang,select.x);
	vec_sub(eang,camera.x);
	vec_to_angle(camera.pan,eang);
}

function cam_rot (VECTOR* v_ang)
{
	if (select==NULL) return;
	face_to_select ();
	VECTOR eang;
	VECTOR sang;	
	vec_set(eang,camera.x);vec_sub(eang,select.x);
	vec_set(sang,vector(-vec_length(eang),0,0));
	vec_rotate(sang,vector(camera.pan+v_ang.x,camera.tilt+v_ang.y,camera.roll+v_ang.z));
	vec_set(eang,select.x);vec_add(eang,sang);
	vec_set(camera.x,eang);
	face_to_select ();
}

function go_right () {cam_rot (vector(10,0,0));}
function go_left () {cam_rot (vector(-10,0,0));}
function go_up () {cam_rot (vector(0,-10,0));}
function go_down () {cam_rot (vector(0,10,0));}

function cam_axix_go (VECTOR* axis)
{
	if (select==NULL) return;
	var dist;
	VECTOR local;
	vec_set(local,select.x);vec_sub(local,camera.x);
	dist = vec_length(local);
	vec_set(local,select.x);
	vec_add(local,vector(dist*axis.x,dist*axis.y,dist*axis.z));	
	vec_set(camera.x,local);
	face_to_select ();
}

function cam_axis_x () {cam_axix_go(vector(1,0,0));}
function cam_axis_y () {cam_axix_go(vector(0,1,0));}
function cam_axis_z () {cam_axix_go(vector(0,0,1));}



