// PCE loader, based on the VLE level loader. Credits to Shadow969 
var ent_pce_group=0; //dont change this in your script
STRING* pce_nomaterial = "nomaterial";

#define MAP_OBJ 0
#define GAME_CONTROL 1
#define MAKE_CONST 2
#define BOX 3
#define SPHERE 4
#define CYLINDER 5
#define POLY 6

#define pce_scene skill50
#define pce_group skill51
#define pce_obj_type skill52
#define phtype skill53
#define pce_const_type skill54
#define const_id skill55
#define pce_name skill56
#define pce_bonesent skill57
#define pce_constrain skill58
#define pce_entstring1 skill59
#define pce_entstring2 skill60

#define pce_const_invert skill61


/////////////////////////////////////////////////////////////////
//Functions for setting action and material

MATERIAL* mat_for_str(STRING* name)
{
	MATERIAL* temp_mat = *((MATERIAL**)engine_getvar(name,0));
	return(temp_mat);
}

void* func_for_str(char* name)
{
	void* temp_func = *((void**)engine_getvar(name,0));
	return(temp_func);
}
//////////////////////////////////////////////////////////////////



function read_skill_vector (var file_handle,var *sk1,var *sk2,var *sk3)
{
	*sk1 = file_var_read(file_handle);
	*sk2 = file_var_read(file_handle);
	*sk3 = file_var_read(file_handle);
}

function read_vector(var file_handle,VECTOR* vec)
{
	vec.x = file_var_read (file_handle);
	vec.y = file_var_read (file_handle);
	vec.z = file_var_read (file_handle);
}

function rotate_skill_vector (var* sk1,var* sk2,var* sk3,VECTOR* vang)
{
	VECTOR an;vec_set(an,vector(sk1,sk2,sk3));
	vec_rotate(an,vang);
	*sk1=an.x;*sk2=an.y;*sk3=an.z;
}

/////////////////////////////////////////////////////////////////
ENTITY*  load_create_ent(var file_handle)
{	
	var obj_type;ENTITY* read_ent; 
	STRING* read_file = str_create("#20");
	STRING* read_action = str_create("#20");
	obj_type = file_var_read(file_handle); 
	if (file_str_read (file_handle,read_file)<0) return (NULL);
	if (file_str_read (file_handle,read_action)<0) return (NULL);
	
	if (engine_getscript(_chr(read_action)))
 	{	
 		void* temp_action = func_for_str(_chr(read_action));
 		read_ent = ent_create(read_file,nullvector,temp_action);
 		read_ent.pce_obj_type=obj_type;c_setminmax(read_ent);
 		return(read_ent);
 	}
 	else 
 	{ 
 		read_ent = ent_create(read_file,nullvector,NULL);
 		read_ent.pce_obj_type=obj_type;c_setminmax(read_ent);
 		return(read_ent);	
 	}
	
}

function load_set_ent(ENTITY* this,var group,VECTOR* offset,var file_handle)
{
	
	VECTOR vec;
	STRING* name = str_create("#25");
	STRING* constrain = str_create("#25");
	STRING* bones_ent = str_create("#25");
	STRING* entst1 = str_create("#25");
	STRING* entst2 = str_create("#25");
	STRING* _material = str_create("#25");
	
	file_str_read (file_handle,name);
	file_str_read (file_handle,constrain);
	file_str_read (file_handle,bones_ent);
	file_str_read (file_handle,entst1);
	file_str_read (file_handle,entst2);
	file_str_read (file_handle,_material);
	
	if (!str_cmpi(pce_nomaterial,_material))
	{
	MATERIAL* temp_mat = mat_for_str(_chr(_material));
	if (temp_mat!=NULL&&!str_cmpi(_material,pce_nomaterial)) this.material = temp_mat;
	}
	
	this.pce_name = handle (name);this.pce_constrain  = handle (constrain);
	this.pce_bonesent = handle (bones_ent);
	this.pce_entstring1  = handle (entst1);this.pce_entstring2  = handle (entst2);
	this.pce_scene=1;this.pce_group=group;
	
	
	read_skill_vector (file_handle,this.x,this.y,this.z);vec_add(this.x,offset);
	read_skill_vector (file_handle,this.pan,this.tilt,this.roll);
	read_skill_vector (file_handle,this.scale_x,this.scale_y,this.scale_z);
	if (file_var_read(file_handle)) set(this,FLAG1); else reset(this,FLAG1);
	if (file_var_read(file_handle)) set(this,FLAG2); else reset(this,FLAG2);
	if (file_var_read(file_handle)) set(this,FLAG3); else reset(this,FLAG3);
	if (file_var_read(file_handle)) set(this,FLAG4); else reset(this,FLAG4);
	if (file_var_read(file_handle)) set(this,FLAG5); else reset(this,FLAG5);
	if (file_var_read(file_handle)) set(this,FLAG6); else reset(this,FLAG6);
	if (file_var_read(file_handle)) set(this,FLAG7); else reset(this,FLAG7);
	if (file_var_read(file_handle)) set(this,FLAG8); else reset(this,FLAG8);
	
	if (file_var_read(file_handle)) set(this,PASSABLE); else reset(this,PASSABLE);
	if (file_var_read(file_handle)) set(this,POLYGON); else reset(this,POLYGON);
	if (file_var_read(file_handle)) set(this,SHADOW); else reset(this,SHADOW);
	if (file_var_read(file_handle)) set(this,CAST); else reset(this,CAST);
	if (file_var_read(file_handle)) set(this,TRANSLUCENT); else reset(this,TRANSLUCENT);
	if (file_var_read(file_handle)) set(this,BRIGHT); else reset(this,BRIGHT);
	if (file_var_read(file_handle)) set(this,LIGHT); else reset(this,LIGHT);
	if (file_var_read(file_handle)) this.flags2 |= SPOTLIGHT; else this.flags2 &= ~SPOTLIGHT;
	if (file_var_read(file_handle)) set(this,UNLIT); else reset(this,UNLIT);
	if (file_var_read(file_handle)) set(this,OVERLAY); else reset(this,OVERLAY);
	if (file_var_read(file_handle)) set(this,DECAL); else reset(this,DECAL);
	if (file_var_read(file_handle)) set(this,NOFOG); else reset(this,NOFOG);
	if (file_var_read(file_handle)) set(this,NOFILTER); else reset(this,NOFILTER);
	if (file_var_read(file_handle)) set(this,INVISIBLE); else reset(this,INVISIBLE);
	if (file_var_read(file_handle)) set(this,ZNEAR); else reset(this,ZNEAR);
	
	this.skill1=file_var_read (file_handle);this.skill2=file_var_read (file_handle);
	this.skill3=file_var_read (file_handle);this.skill4=file_var_read (file_handle);
	this.skill5=file_var_read (file_handle);this.skill6=file_var_read (file_handle);
	this.skill7=file_var_read (file_handle);this.skill8=file_var_read (file_handle);
	this.skill9=file_var_read (file_handle);this.skill10=file_var_read (file_handle);
	this.alpha=file_var_read (file_handle);this.ambient=file_var_read (file_handle);
	this.lightrange=file_var_read (file_handle);this.red=file_var_read (file_handle);
	this.green=file_var_read (file_handle);this.blue=file_var_read (file_handle);
	
	read_skill_vector (file_handle,this.skill94,this.skill95,this.skill96);
	read_skill_vector (file_handle,this.skill97,this.skill98,this.skill99);
	read_skill_vector (file_handle,this.skill65,this.skill66,this.skill67);
	
	read_skill_vector (file_handle,this.skill70,this.skill71,this.skill72);
	read_skill_vector (file_handle,this.skill73,this.skill74,this.skill75);
	read_skill_vector (file_handle,this.skill76,this.skill77,this.skill78);
	read_skill_vector (file_handle,this.skill79,this.skill80,this.skill81);
	read_skill_vector (file_handle,this.skill82,this.skill83,this.skill84);
	read_skill_vector (file_handle,this.skill85,this.skill86,this.skill87);
	
	read_skill_vector (file_handle,this.skill88,this.skill89,this.skill90);
	read_skill_vector (file_handle,this.skill91,this.skill92,this.skill93);
	this.pce_const_type = file_var_read(file_handle);
	read_vector(file_handle,vec);//if (vec.x) set(this,INVISIBLE);this.pce_const_invert=vec.y;
	c_setminmax(this);
}
	
function ent_setph (ENTITY* this)	
{
	VECTOR vec;
	
if (this.pce_obj_type==BOX) if (phent_settype(this,PH_RIGID,PH_BOX)) {this.phtype=BOX;}
	if (this.pce_obj_type==SPHERE) if (phent_settype(this,PH_RIGID,PH_SPHERE)) this.phtype=SPHERE;
	if (this.pce_obj_type==CYLINDER) if (phent_settype(this,PH_RIGID,PH_CYLINDER)) this.phtype=CYLINDER;
	if (this.pce_obj_type==POLY) if (phent_settype(this,PH_RIGID,PH_POLY)) this.phtype=POLY;
	
	if (this.phtype) 
	{
		vec_set(vec,vector(this.skill94,this.skill95,this.skill96));
		if (vec_length(vector(vec.x,vec.y,0))) phent_setmaxspeed(this,vec.x,vec.y);
		vec_set(vec,vector(this.skill97,this.skill98,this.skill99));
		phent_setmass (this,vec.x,PH_SPHERE);phent_setdamping(this,vec.y,vec.z);
		vec_set(vec,vector(this.skill65,this.skill66,this.skill67));
		phent_setelasticity(this,vec.x,vec.y);phent_setfriction (this,vec.z);
	}
}

function pce_setph (var group)
{
	ENTITY* ent=ent_next(NULL);
	while (ent!=NULL)
	{
	if (ent.pce_scene==1&&ent.pce_group==group) {ent_setph (ent);}
	ent=ent_next(ent);
	}
}

ENTITY* pce_find_by_name (STRING* name,var group)
{
	ENTITY* ent=ent_next(NULL);
	STRING* fname = "#30";
	while (ent!=NULL)
	{
		if (ent.pce_scene==1&&ent.pce_group==group)
		{
			str_cpy(fname,ptr_for_handle(ent.pce_name));
			if (str_cmpi(fname,name)) 
			return (ent);
		}
		ent = ent_next (ent);
	}
	return (NULL);
}

function  constrain_set (var group,var ragdoll,VECTOR* offset)
{
	ENTITY* ent=ent_next(NULL);
	ENTITY* ent1;
	ENTITY* ent2;
	STRING* name = "#30";
	STRING* constrain = "#30";
	VECTOR param1;
	VECTOR param2;
	VECTOR param3;
	VECTOR pos;
	VECTOR eang;
	VECTOR epos;
	
	while (ent!=NULL)
	{
		if (ent.pce_scene==1&&ent.pce_group==group&&ent.pce_obj_type>=2&&ent.pce_obj_type<=6&&ent.pce_const_type>0)
		{
			
			str_cpy(name,ptr_for_handle(ent.pce_name));
			str_cpy(constrain,ptr_for_handle(ent.pce_constrain));
			you = pce_find_by_name (constrain,group);ent1=ent;ent2=you;
			if (ent.pce_obj_type==2) 
			{
				str_cpy(name,ptr_for_handle(ent.pce_entstring2));
				ent1 = pce_find_by_name (name,group);
			}
			if (!ent1.phtype) {ent1=NULL;}
			if (ent1!=NULL&&ent.pce_const_invert&&ent2!=NULL) {you=ent1;ent1=ent2;ent2=you;}
			if (ent.pce_const_type==1&&ent1!=NULL) {ent.const_id=phcon_add(PH_HINGE,ent1,ent2);}
			if (ent.pce_const_type==2&&ent1!=NULL) {ent.const_id=phcon_add(PH_BALL,ent1,ent2);}
			if (ent.pce_const_type==3&&ent1!=NULL) {ent.const_id=phcon_add(PH_WHEEL,ent1,ent2);}
			if (ent.pce_const_type==4&&ent1!=NULL) {ent.const_id=phcon_add(PH_SLIDER,ent1,ent2);}
				
			if (ent.const_id&&ent1!=NULL) 
			{
				if (vec_length(vector(ent.skill70,ent.skill71,ent.skill72))||ent2==NULL) 
				{
					if (!vec_length(vector(ent.skill70,ent.skill71,ent.skill72))) vec_set(pos,ent1.x);
						else vec_set(pos,vector(ent.skill70,ent.skill71,ent.skill72));
				} 
					else
				{	
					vector(ent.skill70,ent.skill71,ent.skill72);
					vec_set(pos,ent1.x);vec_sub(pos,ent2.x);
					vec_scale(pos,0.5);vec_add(pos,ent2.x);
				}
				if (ent.pce_const_type!=4) vec_add(pos,offset);
			
				vec_set(param2,vector(ent.skill73,ent.skill74,ent.skill75)); 
				vec_set(param3,vector(ent.skill76,ent.skill77,ent.skill78));
				
				if (ragdoll&&ent.pce_obj_type!=2)
				{
					if (ent.pce_const_type==4) vec_rotate(pos,ent.pan);
					if (ent.pce_const_type==1||ent.pce_const_type==3) vec_rotate(param2,ent.pan);
					if (ent.pce_const_type==3) vec_rotate(param3,ent.pan);
					if (ent.pce_const_type>=1||ent.pce_const_type<=3)  
					{
						if (ent.pce_const_type==3) vec_set(pos,ent.x); else 
						if (you!=NULL)
						{
							vec_set(pos,you.x);vec_sub(pos,ent.x);vec_normalize(pos,1);
							vec_add(pos,ent.x);
						}
					}
				}
				phcon_setparams1 (ent.const_id,pos,param2,param3);
				vec_set(param1,vector(ent.skill79,ent.skill80,ent.skill81));
				vec_set(param2,vector(ent.skill82,ent.skill83,ent.skill84));
				vec_set(param3,vector(ent.skill85,ent.skill86,ent.skill87));
				
				phcon_setparams2 (ent.const_id,param1,param2,param3);
				vec_set(param1,vector(ent.skill88,ent.skill89,ent.skill90));
				vec_set(param2,vector(ent.skill91,ent.skill92,ent.skill93));
				phcon_setmotor (ent.const_id,param1,param2,nullvector);
			}
		}
		ent=ent_next(ent);
	}
}

function pce_load_scene (STRING* file,VECTOR* offset)
{
	ent_pce_group++;
	ENTITY* pce;VECTOR offs;vec_set(offs,offset);
	var file_handle = file_open_read(file);
	if (!file_handle) return (0);
	while (pce=load_create_ent(file_handle)) {load_set_ent(pce,ent_pce_group,offs,file_handle);}	
	wait(1);
	pce_setph (ent_pce_group);
	constrain_set (ent_pce_group,0,offs);
	file_close(file_handle);
	return(ent_pce_group);
}

function get_bone_index (ENTITY* this,STRING* st) //return index
{
	var bnum = ent_bones (this);
	var count;
	STRING* b_name = "#40";
	if (bnum==0) return (0);
	for (count=1;count<=bnum;count++) 
	{
		ent_boneparent(this,b_name,count);
		if (str_cmpi(b_name,st)) return(count);
	}
	return(0);
}

function set_regdoll (ENTITY* bo,var group)
{
	ENTITY* ent=ent_next(NULL);
	STRING* bone_name = "#25";
	VECTOR vec;
	var index;
	while (ent!=NULL)
	{
		if (ent.pce_scene==1&&ent.pce_group==group)
		{
			str_cpy(bone_name,ptr_for_handle(ent.pce_entstring1));
			if (index=get_bone_index(bo,bone_name))
			{
				vec_for_bone(vec,bo,bone_name);vec_set(ent.x,vec);
				ang_for_bone(vec,bo,bone_name);vec_set(ent.pan,vec);
			}
		}
		ent = ent_next (ent);
	}
}


function pce_load_regdoll (STRING* file,ENTITY* this)
{
	ent_pce_group++;
	ENTITY* pce;
	var file_handle = file_open_read(file);
	if (!file_handle) return (0);
	while (pce=load_create_ent(file_handle)) 
	{load_set_ent(pce,ent_pce_group,nullvector,file_handle);}	
	set_regdoll (this,ent_pce_group);
	wait(1);
	pce_setph (ent_pce_group);
	constrain_set (ent_pce_group,1,nullvector);
	file_close(file_handle);
	return(ent_pce_group);
	
}

function get_count_of_parent (ENTITY* this,var index)
{	
	long b_handle=index;var count=0;
	while ((b_handle=ent_boneparent(this,b_handle,0))!=NULL) count++;
	return (count);
}

action attach_ent_bones ()
{
	var b_count=0; //count of attach bone to ent
	var ent_num=0;
	var index;
	var attach_ent[100]; //up to 100 bones, attach_ent 
	var sort_ent[100]; 
	var b_priority[100]; //need for sorting ents
	var max_priority=0; //need for sorting ents
	var priority=0; //need for sorting ents
	
	VECTOR b_pos;
	VECTOR b_move;
	VECTOR b_ang;
	VECTOR b_ang1;
	var debug=0;
	
	STRING* bone_name = "#25";
	STRING* ent_bo = "#25"; 
	STRING* name = "#25";
	
	while (!my.pce_scene) wait(1);
	ENTITY* ent = ent_next (NULL);
	while (ent!=NULL)
	{
		if (ent.pce_scene==1&&my.pce_group==ent.pce_group)
		{
			str_cpy(ent_bo,ptr_for_handle(ent.pce_bonesent));
			str_cpy(name,ptr_for_handle(my.pce_name));
			if (str_cmpi(name,ent_bo)) 
			{
				str_cpy(bone_name,ptr_for_handle(ent.pce_entstring1));
				if (index=get_bone_index(my,bone_name)) 
				{
					attach_ent[b_count]=handle(ent);
					b_priority[b_count]=get_count_of_parent(my,index);//set bone priotity
					if (max_priority<b_priority[b_count]) {max_priority=b_priority[b_count];}
					b_count++;
				} 
			}
		} 
		ent=ent_next(ent);
	}

	// sort ent by bones parent
	index=0;while (priority<=max_priority) 
	{
		ent_num=0;
		while(ent_num<b_count)
		{
			if (b_priority[ent_num]==priority) {sort_ent[index]=attach_ent[ent_num];index++;}
			ent_num++;
		}
		priority++;
	}
	ent_bonereset_all(my);
	
	//wait(-10);
	while (my!=NULL)
	{
		ent_num=0;
		while (ent_num<b_count)
		{
			ent=ptr_for_handle(sort_ent[ent_num]);
			str_cpy(bone_name,ptr_for_handle(ent.pce_entstring1));
			if (ent_num==0&&is(my,FLAG1)) vec_set(my.x,ent.x);
			ent_bonereset(my,bone_name);
			vec_for_bone(b_pos,my,bone_name);
			ang_for_bone(b_ang,my,bone_name);
			vec_set(b_move,ent.x);vec_sub(b_move,b_pos);
			b_move.x/= my.scale_x;b_move.y/= my.scale_y; b_move.z/= my.scale_z; 
			vec_rotateback (b_move,b_ang);///
			
			b_ang.x = 360-b_ang.x;b_ang.y = 360-b_ang.y;b_ang.z = 360-b_ang.z;
			vec_set(b_ang1,nullvector);
			ang_add(b_ang1,vector(b_ang.x,0,0));
			ang_add(b_ang1,vector(0,b_ang.y,0));
			ang_add(b_ang1,vector(0,0,b_ang.z));
			ang_rotate(b_ang1,ent.pan);
			ent_bonerotate(my,bone_name,b_ang1);
			ent_bonemove(my,bone_name,b_move);	
			ent_num++;
		}
		wait(1);
	}
}